unit plSQLTime;
interface
type
 TDate4 = record w1,w2:word; end;  PDate4 = ^TDate4;
 TDate8 = record d1,d2:dword; end; PDate8 = ^TDate8;
 TSQLTime = record
  dYear,dMonth,dDay,dHour,dMinute,dSecond,dMilliseconds,dDayOfWeek:word;
 end;
 PSQLTime = ^TSQLTime;
procedure ConvertFromD4(pd4:PDate4;pd8:PDate8);
procedure ConvertToSystime(pd8:PDate8;ps:PSQLTime);
function  SystimeToStr(ps:PSQLTime;b:boolean):string;
implementation

const a:array[0..1,0..11]of byte = (
 (31,28,31,30,31,30,31,31,30,31,30,31),
 (31,29,31,30,31,30,31,31,30,31,30,31));

procedure ConvertFromD4(pd4:PDate4;pd8:PDate8);
begin
 pd8^.d2:=pd4^.w2;
 pd8^.d1:=pd4^.w1*18000;
end;

procedure ConvertToSystime(pd8:PDate8;ps:PSQLTime);
var d,y,v:dword;
    i,b,w:byte;
begin
 d:=pd8^.d1 and $1FFFFFF;
 with ps^ do begin
  dHour:=d div(1080000);
  dMinute:=(d div 18000) mod 60;
  dSecond:=(d div 300) mod 60;
  dMilliseconds:=((d mod 300)*10 div 3)
        +(((d mod 300)*10 mod 3) div 2);
 end;
 d:=pd8^.d2;
 if(d<=$2D247F)then begin {4 digits in year - max = 9999-12-31}
  y:=(d div 365)+1;
  repeat
   dec(y);
   v:=(y div 4)-(y div 100)+((y+300) div 400);
   if(y mod 4 = 0)and((y mod 100 <> 0)or((y+300) mod 400 = 0))
    then b:=1 else b:=0;
   inc(v,(y*365)-b);
  until(v<=d);
  w:=(d+1) mod 7;
  dec(d,v);
  i:=0;
  repeat
   if(d+1 <= a[b,i]) then break;
   dec(d,a[b,i]);
   inc(i);
  until i>10;
  with ps^ do begin
   dYear:=y+1900;
   dMonth:=i+1;
   dDay:=d+1;
   dDayOfWeek:=w;
  end;
 end;
end;

function SystimeToStr(ps:PSQLTime;b:boolean):string;
var s:string;
begin
 result:='';
 if ps<>nil then with ps^ do begin
  s:='  ';
  str(dYear,s);result:=s+'-';
  if dMonth<10 then result+='0';str(dMonth,s);result+=s+'-';
  if dDay<10 then result+='0';str(dDay,s);result+=s+' ';
  if dHour<10 then result+='0';str(dHour,s);result+=s+':';
  if dMinute<10 then result+='0';str(dMinute,s);result+=s;
  if b then begin
   result+=':';
   if dSecond<10 then result+='0';str(dSecond,s);result+=s+'.';
   if dMilliseconds<100 then result+='0';
   if dMilliseconds<10 then result+='0';str(dMilliseconds,s);result+=s;
  end;
 end;
end;
end.
