{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
unit plFile64;
interface
{$MODE objfpc}
{ Include Win32 Consts,Types }
{$I plFile64.inc}
function FileSeek(F:longint; const Offset: Int64; Origin: Integer): Int64;
function FilePos(F:longint):Int64;
function FileSize(F:longint):Int64;
function FileReadStr(F:longint;Count:Byte):String;
Function DirCreate(s:String):Integer;

Function FileOpen (Const FileName : string; Mode : Integer) : Longint;
Function FileCreate (Const FileName : String) : Longint;
Function FileRead (Handle : Longint; Var Buffer; Count : longint) : Longint;
Function FileWrite (Handle : Longint; const Buffer; Count : Longint) : Longint;
Procedure FileClose (Handle : Longint);

type Int64Rec = packed record Lo,Hi:dword end;

implementation
//uses SysUtils;

//-------------------------------------------------------------------------

function SetFilePointer(l1,l2 : longint;l3 : pointer;l4 : longint) : longint;stdcall;
  external 'kernel32' name 'SetFilePointer';
function GetFileSize(h:longint;p:pointer) : longint;stdcall;
  external 'kernel32' name 'GetFileSize';
function WriteFile(fh:longint;buf:pointer;len:longint;var loaded:longint;
  overlap:pointer):longint;stdcall;
  external 'kernel32' name 'WriteFile';
function ReadFile(fh:longint;buf:pointer;len:longint;var loaded:longint;
  overlap:pointer):longint;stdcall;
  external 'kernel32' name 'ReadFile';
function CloseHandle(h : longint) : longint;stdcall;
  external 'kernel32' name 'CloseHandle';
function CreateFile(name : pointer;access,sharing : longint;
  security : pointer;how,attr,template : longint) : longint;stdcall;
  external 'kernel32' name 'CreateFileA';

function FileSeek(F:longint; const Offset: Int64; Origin: Integer): Int64;
begin
  Result := Offset;
  Int64Rec(Result).Lo := SetFilePointer(F,Int64Rec(Result).Lo,@Int64Rec(Result).Hi,Origin);
end;

function FileSize(F:longint):Int64;
//var currpos:Int64;
begin
  Int64Rec(Result).Lo := GetFileSize(F,@Int64Rec(Result).Hi);
end;

//-------------------------------------------------------------------------

function FilePos(F:longint):Int64;
begin
 Result:=FileSeek(F,Int64(0),Int64(fsFromCurrent))
end;
{function FileSize(F:longint):Int64;
var currpos:Int64;
begin
 currpos:=FileSeek(F,Int64(0),Int64(fsFromCurrent));
 FileSize:=FileSeek(F,Int64(0),Int64(fsFromCurrent));
 FileSeek(F,currpos,Int64(fsFromBeginning));
end;}
function FileReadStr(F:longint;Count:Byte):String;
begin
 byte(result[0]):=Count;
 if FileRead(F,result[1],Count)=-1 then result:='';
end;
Function DirCreate(s:String):Integer;
{----------[ ᮧ  ⠫  મ S
              ⠫  稢 '\'
}
var s1:string;
    i,err:integer;
begin
 s1:='';
 err:=0;
 while pos('/',s)>0 do s[pos('/',s)]:='\';
 i:=pos(':\',s);
 if i>0 then begin
  s1:=copy(s,1,i+1);
  s:=copy(s,i+2,length(s)-i+1);
 end;
 repeat
  i:=pos('\',s);
  if i>0 then begin
   s1:=s1+copy(s,1,i-1);
   s:=copy(s,i+1,length(s)-i);
   {$I-} MkDir(s1); {$I+}
   err:=IOResult;
   if err=5 then err:=0;
   s1:=s1+'\';
  end;
 until (i=0)or(err<>0);
 DirCreate:=err;
end; {DirCreate}

//-------------------------------------------------------------------------

Function FileOpen (Const FileName : string; Mode : Integer) : Longint;
const
  AccessMode: array[0..2] of Integer = (
    GENERIC_READ,
    GENERIC_WRITE,
    GENERIC_READ or GENERIC_WRITE);
  ShareMode: array[0..4] of Integer = (
               0,
               0,
               FILE_SHARE_READ,
               FILE_SHARE_WRITE,
               FILE_SHARE_READ or FILE_SHARE_WRITE);
Var
  FN : string;
begin
  FN:=FileName+#0;
  result := CreateFile(@FN[1], dword(AccessMode[Mode and 3]),
                       dword(ShareMode[(Mode and $F0) shr 4]), nil, OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL, 0);
end;

Function FileCreate (Const FileName : String) : Longint;
Var
  FN : string;
begin
  FN:=FileName+#0;
  Result := CreateFile(@FN[1], GENERIC_READ or GENERIC_WRITE,
                       0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
end;

Function FileRead (Handle : Longint; Var Buffer; Count : longint) : Longint;
Var
  res : longint;
begin
  if boolean(ReadFile(Handle, @Buffer, Count, res, nil)) then
   FileRead:=Res
  else
   FileRead:=-1;
end;

Function FileWrite (Handle : Longint; const Buffer; Count : Longint) : Longint;
Var
  Res : longint;
begin
  if boolean(WriteFile(Handle, @Buffer, Count, Res, nil)) then
   FileWrite:=Res
  else
   FileWrite:=-1;
end;

Procedure FileClose (Handle : Longint);
begin
  if Handle<=4 then
   exit;
  CloseHandle(Handle);
end;

end.
