{==}
const
    CmdfPageHeader70      = $01;
    CmdfPageSize          = $2000;
    CmdfPagePerMB         = $100000 div CmdfPageSize;
    CmdfPagePerGB         = $40000000 div CmdfPageSize;
    CmdfPageHeaderSize    = $60;
    CmdfPageMaxSlots      = (CmdfPageSize - CmdfPageHeaderSize) shr 1;

    CmdfPageData          = $01;
    CmdfPageIndex         = $02;
    CmdfPageTextMix       = $03;
    CmdfPageTextTree      = $04;
    CmdfPageWF            = $06;
    CmdfPageSort          = $07;
    CmdfPageGAM           = $08;
    CmdfPageSGAM          = $09;
    CmdfPageIAM           = $0A;
    CmdfPagePFS           = $0B;
    CmdfPageBoot          = $0D;
    CmdfPageSysconfig     = $0E;
    CmdfPageFileheader    = $0F;
    CmdfPageDiffMapPage   = $10;
    CmdfPageMlMapPage     = $11;
    CmdfPageDumpHeader    = $64;
    CmdfPageDumpTrailer   = $65;
{=====================================================================}
type
    PmdfPageId = ^TmdfPageId;
    TmdfPageId = packed record
     _id:dword;
     _fid:word;
    end;

    PmdfPageLSN = ^TmdfPageLSN;
    TmdfPageLSN = packed record
     d1,d2:dword;
     w1:word;
    end;

    PmdfPageHeader = ^TmdfPageHeader;
    TmdfPageHeader = packed record
     m_headerVersion,
     m_type,
     m_typeFlagBits,
     m_level,
     m_flagBits,
     m_reservedB:byte;
     m_indexId:word;
     m_prev:TmdfPageId;
     pminlen:word;
     m_next:TmdfPageId;
     m_slotCnt:word;
     m_objId:dword;
     m_freeCnt,
     m_freeData:word;
     m_pageId:TmdfPageId;
     m_reservedCnt:word;
     m_lsn:TmdfPageLSN;
     m_xactReserved:word;
     m_xdesId:TmdfPageId;
     m_ghostRecCnt:word;
     m_tornBits:dword;
     w40,w42,w44,w46,w48,w4A,w4C,w4E,
     w50,w52,w54,w56,w58,w5A,w5C,w5E:word;
    end;

    PmdfPage = ^TmdfPage;
    TmdfPage = packed record
    case byte of
     0:(_buff:array[0..CmdfPageSize-1]of byte);
     1:(_ph:TmdfPageHeader;
        _ind:array[1..CmdfPageMaxSlots]of word);
    end;

    PmdfPageStream = ^TmdfPageStream;
    TmdfPageStream = packed record
     _file:longint;
     _start:Int64;
     _size:Int64;
     _page_cnt:dword;
     _first_cached_page:dword;
     _number_cached_pages:dword;
     _pbuff:pointer;
     _version:byte;

     _objects:pointer;
     _columns:pointer;
    end;

    PmdfForkStack = ^TmdfForkStack;
    TmdfForkStack = packed record
     _lsn:TmdfPageLSN;
     _w:word;
     _guid:GUID;
     _data:array [0..27] of byte; 
    end;

