unit mdfTable;
interface
uses mdfPage,mdfType,plMem,plType,plUni,plFile64,plStr{,sysutils};
const CmdfTableMaxFields = $0FFFF;

  //(MaxTableCount*((MaxFieldCount*SizeOf(string[30]))+SizeOf(dword)+SizeOf(byte)))+SizeOf(dword)+SizeOf(byte);
  CmdfUnionTablesObjects = (1*((4*31)+5))+12;
  CmdfUnionTablesColumns = (1*((12*31)+5))+12;

type

    PmdfTableSlot = ^TmdfTableSlot;
    TmdfTableSlot = array[0..CmdfPageSize-CmdfPageHeaderSize-3]of byte;

    PmdfAllocId = ^TmdfAllocId;
    TmdfAllocId = packed record
     case byte of
      0:(_auid:qword;);
      1:(_w1:word;
         _id:dword;
         _w2:word;);
    end;

    PmdfIAM = ^TmdfIAM;
    TmdfIAM = packed record
     _first_pid:TmdfPageId;
     _page:TmdfPage;
     _last:byte; // ᫨ extent=false,   ᫥ ࠭ ࠭
                 //  ᬥ蠭 ⥭⮢,   ᫥ ⥭;
     _lastext:longint; // ᫥ ࠭ ⥭ (   ᨢ)
     _extent:boolean;
    end;

    PmdfTableField = ^TmdfTableField;
    TmdfTableField = packed record
     _minsize:word;
     _maxsize:word;
     _type:word; // byte
     _size:word;
     _bitnum:byte;   // for type_bit
     _pvalue:pointer;
     _pname:pointer; // to string
     //-------------------------------- from syscolumns
     _xusertype:word;
     _xprec:byte;
     _xscale:byte;
     _xoffset:word;
     _bitpos:byte;
     _colid:word;
     _colstat:word;
     _typestat:byte;
     //--------------------------------
     _link:boolean;
    end;

    PmdfTableFields = ^TmdfTableFields;
    TmdfTableFields = array[1..CmdfTableMaxFields] of TmdfTableField;

    PmdfTable = ^TmdfTable;
    TmdfTable = packed record
     _stream:PmdfPageStream;
     _id:dword;
     _current_row:word;
     _rowLength:word;
     _prow:PmdfTableSlot;
     _first_pid:TmdfPageId;
     _field_count:word;
     _clustered:boolean;
     _field:PmdfTableFields;
     _page:TmdfPage;
     _rowCnt:qword;
     _ex:boolean;
     _auid:TmdfAllocId;
     _iam:PmdfIAM;
    end;

    PmdfBlob = ^TmdfBlob;
    TmdfBlob = packed record
     _size:dword;
     _pvalue:pointer;
    end;

    PmdfBlobLink = ^TmdfBlobLink;
    TmdfBlobLink = packed record
     _blobId:qword;
     _pid:TmdfPageId;
     _slot:word;
    end;

    PmdfIAMMix = ^TmdfIAMMix;
    TmdfIAMMix = packed record
     _head:word;
     _size:word;
     _trash:array[0..35]of byte;
     _pid:array[0..8]of TmdfPageId;
    end;

    PmdfIAMExt = ^TmdfIAMExt;
    TmdfIAMExt = packed record
     _head:word;
     _size:word;
     _data:AByte;
    end;

    PmdfUnionFields = ^TmdfUnionFields;
    TmdfUnionFields = packed record
     t_id:dword;      // object id
     f_cnt:byte;      // count of fields
     f:array[1..256]of string[30];
    end;

    PmdfUnionTables = ^TmdfUnionTables;
    TmdfUnionTables = packed record
     name:string[10]; // name of union
     t_cnt:byte;      // count of tables
     t:array[1..256]of TmdfUnionFields;
    end;

    PmdfTypeInfo = ^TmdfTypeInfo;
    TmdfTypeInfo = packed record
     tab:PmdfTable;
     _name:string;       {1}
     _xtype:byte;        {2}
     _status:byte;       {3}
     _xusertype:word;    {4}
     _length:word;       {5}
     _xprec:byte;        {6}
     _xscale:byte;       {7}
     _tdefault:dword;    {8}
     _domain:dword;      {9}
     _uid:word;         {10}
     _reserved:word;    {11}
     _collationid:dword;{12}
    end;

{=====================================================================}
function  getFieldNumber(tab:PmdfTable;field_name:string):word;
function  getFieldName(tab:PmdfTable;field_number:word):string;
procedure mdfGetBlob(p:PmdfPageStream;b:PmdfBlobLink;var blob:TmdfBlob);
function  mdfTableOpen(q:PmdfPageStream;id:dword;scan:byte):PmdfTable;
function  mdfTableOpenEx(q:PmdfPageStream;id:dword;scan:byte):PmdfTable;
procedure mdfTableClose(var p:PmdfTable);
function  mdfTableFirstRow(p:PmdfTable):boolean;
function  mdfTableNextRow(p:PmdfTable):boolean;
function  mdfTableRowParse(p:PmdfTable):boolean;
function  mdfTableRowParseEx(p:PmdfTable):boolean;
function  mdfTableInitFromTable(p:PmdfTable):boolean;
function  mdfTableInitFromTableEx(p:PmdfTable):boolean;
function  mdfTableInitFromTableEx2(p:PmdfTable):boolean;
procedure mdfTableFieldInit(var field:TmdfTableField;field_type,field_size:word;field_name:string);
function  mdfInternalTableOpen(q:PmdfPageStream;ptype:byte):PmdfTable;
{=====================================================================}
function mdfSysTablesInitTable(p:PmdfTable;id:dword):PmdfTable;
{=====================================================================}
implementation
{=====================================================================}
function getRowLength(p:PmdfTable;rowStart:word):word;
var q:^word;
    b:byte;
begin
 if(p<>nil)and(rowStart>=CmdfPageHeaderSize)and(rowStart<CmdfPageSize)then begin
  q:=@p^._page._buff[rowStart];
  b:=pbyte(q)^;
  if(b and $1)=0 then begin
   inc(q);
   inc(dword(q),q^-2);
   if(b and $10)<>0 then inc(dword(q),((q^+7)shr 3)+2);
   if(b and $20)<>0 then begin
    inc(dword(q),q^ shl 1);
    result:=q^ and $7FFF;
   end else result:=dword(q)-dword(@p^._page._buff[rowStart])
  end else result:=p^._page._ph.pminlen;
 end else result:=0;
end;
{---------------------------------------------------------------------}
procedure mdfTableFieldInit(var field:TmdfTableField;field_type,field_size:word;field_name:string);
begin
 with field do begin
  _type:=field_type;
  _maxsize:=field_size;
  _pname:=MemAlloc(byte(field_name[0])+2);
  if _pname<>nil then string(_pname^):=field_name;
 end;
end;
{---------------------------------------------------------------------}
function mdfTableRowParse(p:PmdfTable):boolean;
var row:PmdfTableSlot;
    fields:PmdfTableFields;
    bits:byte;       // ⥪騩   ⮢ 
    i,
    bitsoffs,        // ᬥ饭  ⥪ ⮢ 
    sizef,           // ࠧ   䨪஢ 
    posf,            //     䨪஢ 
    posv,            //  ⥪饣  ६ 
    align:word;      // ᬥ饭  砫 ।  ६ 
    nulls:PAByte;    //  䫠 
    ppos:PAWord;     //  ᯨ᪠  ६ 
                     // (㫥  - ⢮ ⠪ )
   null_present,
   vars_present:boolean;

function fieldIsNull(t:PAByte;i:word):boolean;
// true if is null
begin
 dec(i);
 result:=((t^[(i shr 3)+1])and(byte(1) shl (i and 7)))>0;
end;

begin
 result:=false;
 if p<>nil then begin
  with p^ do begin
   row:=_prow;
   fields:=_field;
  end;
  if(row<>nil)and(fields<>nil)then begin
   if(pbyte(row)^and $0F)<>0 then begin
   //if(pbyte(row)^and 3)<>0 then begin
    (*write('Warning. Skip record with flag 0x',HexStr(pbyte(row)^,1));
    case (pbyte(row)^and $0F) of
     $02: write(' FORWARDED_RECORD');
     $04: write(' FORWARDING_STUB');
     $06: write(' INDEX_RECORD');
     $08: write(' BLOB_FRAGMENT');
     $0A: write(' GHOST_INDEX_RECORD');
     $0C: write(' GHOST_DATA_RECORD');
    end; {case}
    writeln;*)
    exit;
   end;
   bits:=0;
   posf:=4;
   posv:=1;
   ppos:=pointer(row);
   null_present:=(pbyte(row)^and $10)<>0;
   vars_present:=(pbyte(row)^and $20)<>0;
   sizef:=ppos^[2];
   align:=sizef;
   inc(dword(ppos),align);
   nulls:=pointer(ppos);
   inc(dword(nulls),2);
   if null_present then begin
    i:=((ppos^[1]+7)shr 3)+2;
    inc(align,i);
    inc(dword(ppos),i);
   end;
   inc(align,(ppos^[1]+1)shl 1);
   for i:=1 to p^._field_count do begin
    case fields^[i]._type of
     type_bit:begin
      if(bits=0)and(posf-2<sizef)then begin
       bitsoffs:=posf;
       inc(posf,fields^[i]._maxsize);
      end;
      if{((nulls^[((i-1)shr 3)+1]and(1 shl((i-1)and 7)))<>0)or}
       ((null_present)and(fieldIsNull(nulls,i)))
       or((posf>sizef)and(bits=0))then begin
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
       fields^[i]._bitnum:=0;
      end else begin
       fields^[i]._pvalue:=pointer(dword(row)+bitsoffs);
       fields^[i]._size:=fields^[i]._maxsize;
       fields^[i]._bitnum:=bits;
      end;
      if not((posf>sizef)and(bits=0))then bits:=(bits+1)and 7;
     end;
     type_bigint,type_binary,type_char,type_datetime,type_decimal,
     type_float,type_int,type_money,type_nchar,type_numeric,
     type_real,type_smalldatetime,type_smallint,type_smallmoney,type_timestamp,
     type_tinyint,type_uniqueidentifier:begin
      {fixed length}
      // if fieldIsNull(t,i) then begin
      if{((nulls^[((i-1)shr 3)+1]and(1 shl((i-1)and 7)))<>0)}
       ((null_present)and(fieldIsNull(nulls,i)))
       or(posf+fields^[i]._maxsize>sizef)then begin
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
      end else begin
       fields^[i]._pvalue:=pointer(dword(row)+posf);
       fields^[i]._size:=fields^[i]._maxsize;
      end;
      if not(posf+fields^[i]._maxsize>sizef)then begin
       inc(posf,fields^[i]._maxsize);
       //if fields^[i]._type=type_char then inc(posf,2);
       //if fields^[i]._type=type_nchar then inc(posf,2);
      end;
     end;
     type_ntext,type_text,type_image,type_sql_variant,type_xml,
     type_nvarchar{,type_sysname},type_varbinary,type_varchar:begin
      {variable length; systypes.variable = 1}
      inc(posv);
      if(not vars_present)or(ppos^[1]<posv-1)or((ppos^[posv]and $7FFF)=align) then begin // null
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
      end else begin
       fields^[i]._pvalue:=pointer(dword(row)+align);
       fields^[i]._size:=(ppos^[posv]and $7FFF)-align;
       align:=(ppos^[posv]and $7FFF);
      end;
      fields^[i]._link:=(ppos^[posv]and $8000)>0;
(*     end;
     type_ntext,type_text:begin
      {unknown length}
      exit;*)
     end
    else exit;
    end; {case}
   end;
   result:=true;
  end;
 end;
end;
{---------------------------------------------------------------------}
function mdfTableRowParseEx(p:PmdfTable):boolean;
var row:PmdfTableSlot;
    fields:PmdfTableFields;
    bits:byte;       // ⥪騩   ⮢ 
    i,
    bitsoffs,        // ᬥ饭  ⥪ ⮢ 
    sizef,           // ࠧ   䨪஢ 
    posf,            //     䨪஢ 
    posv,            //  ⥪饣  ६ 
    align:word;      // ᬥ饭  砫 ।  ६ 
    nulls:PAByte;    //  䫠 
    ppos:PAWord;     //  ᯨ᪠  ६ 
                     // (㫥  - ⢮ ⠪ )
   null_cnt:word;
   null_present,
   vars_present:boolean;

function fieldIsNull(t:PAByte;i:word):boolean;
// true if is null
begin
 dec(i);
 result:=((t^[(i shr 3)+1])and(byte(1) shl (i and 7)))>0;
end;

begin
 result:=false;
 if(p<>nil)and(p^._prow<>nil) then begin
  with p^ do begin
   row:=_prow;
   if(pbyte(_prow)^and $0F)<>0 then begin
   //if(pbyte(_prow)^and 3)<>0 then begin
    (*write('Warning. Skip record with flag 0x',HexStr(pbyte(row)^,1));
    case (pbyte(_prow)^and $0F) of
     $02: write(' FORWARDED_RECORD');
     $04: write(' FORWARDING_STUB');
     $06: write(' INDEX_RECORD');
     $08: write(' BLOB_FRAGMENT');
     $0A: write(' GHOST_INDEX_RECORD');
     $0C: write(' GHOST_DATA_RECORD');
    end; {case}
    writeln;*)
    exit;
   end;
   fields:=_field;
  end;
  if(row<>nil)and(fields<>nil)then begin
   bits:=0;
   posf:=4;
   posv:=1;

   ppos:=pointer(row);
   null_present:=(pbyte(row)^and $10)<>0;
   vars_present:=(pbyte(row)^and $20)<>0;

   sizef:=ppos^[2]; // ࠧ 䨪..


   align:=sizef;
   inc(dword(ppos),sizef);
   nulls:=pointer(ppos);
   inc(dword(nulls),2);
   if null_present then begin
    null_cnt:=ppos^[1];
    i:=((ppos^[1]+7)shr 3)+2;
    inc(align,i);
    inc(dword(ppos),i);
   end;
   inc(align,(ppos^[1]+1)shl 1);
   for i:=1 to p^._field_count do begin
    case fields^[i]._type of
     type_bit:begin
      //if(bits=0)and(posf-2<sizef)then begin
       //bitsoffs:=posf;
       //inc(posf,fields^[i]._maxsize);
      //end;
      if{((nulls^[((i-1)shr 3)+1]and(1 shl((i-1)and 7)))<>0)or}
       ((null_present)and(((i<=null_cnt)and(fieldIsNull(nulls,i)))or(i>null_cnt)))
       or(fields^[i]._xoffset=0)or(fields^[i]._xoffset and $8000<>0)or(fields^[i]._maxsize=0)
       or(fields^[i]._xoffset>sizef)then begin
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
       fields^[i]._bitnum:=0;
      end else begin
       fields^[i]._pvalue:=pointer(dword(row)+fields^[i]._xoffset);
       fields^[i]._size:=fields^[i]._maxsize;
       fields^[i]._bitnum:=fields^[i]._bitpos;
      end;
      //if not((posf>sizef)and(bits=0))then bits:=(bits+1)and 7;
     end;
     type_bigint,type_binary,type_char,type_datetime,type_decimal,
     type_float,type_int,type_money,type_nchar,type_numeric,
     type_real,type_smalldatetime,type_smallint,type_smallmoney,type_timestamp,
     type_tinyint,type_uniqueidentifier:begin
      {fixed length}
      // if fieldIsNull(t,i) then begin
      if{((nulls^[((i-1)shr 3)+1]and(1 shl((i-1)and 7)))<>0)}
       ((null_present)and(((i<=null_cnt)and(fieldIsNull(nulls,i)))or(i>null_cnt)))
       or(fields^[i]._xoffset=0)or(fields^[i]._xoffset and $8000<>0)or(fields^[i]._maxsize=0)
       or(fields^[i]._xoffset>sizef)or(fields^[i]._xoffset+fields^[i]._maxsize-1>sizef)then begin
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
      end else begin
       fields^[i]._pvalue:=pointer(dword(row)+fields^[i]._xoffset);
       fields^[i]._size:=fields^[i]._maxsize;
      end;
      //if not(posf+fields^[i]._maxsize>sizef)then begin
       //inc(posf,fields^[i]._maxsize);
      //end;
     end;
     type_ntext,type_text,type_image,type_sql_variant,type_xml,
     type_nvarchar{,type_sysname},type_varbinary,type_varchar:begin
      {variable length; systypes.variable = 1}
      if not vars_present then begin
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
      end else begin
       posv:=(not fields^[i]._xoffset)+2;
       if((null_present)and(((i<=null_cnt)and(fieldIsNull(nulls,i)))or(i>null_cnt)))
        or(fields^[i]._xoffset=0)or(ppos^[1]<posv-1)or((posv>2)and((ppos^[posv])=(ppos^[posv-1]and $7FFF)))
        or((posv=2)and(ppos^[posv]=align)) then begin // null
        fields^[i]._pvalue:=nil;
        fields^[i]._size:=0;
       end else begin
        if posv=2 then begin
         fields^[i]._pvalue:=pointer(dword(row)+align);
         fields^[i]._size:=(ppos^[posv]and $7FFF)-align;
        end else begin
         fields^[i]._pvalue:=pointer(dword(row)+(ppos^[posv-1]and $7FFF));
         fields^[i]._size:=(ppos^[posv]and $7FFF)-(ppos^[posv-1]and $7FFF);
        end;
        //align:=(ppos^[posv]and $7FFF);
       end;
       fields^[i]._link:=(ppos^[posv]and $8000)>0;
       {if(ppos^[1]<posv-1)or((posv>2)and((ppos^[posv]and $7FFF)=(ppos^[posv-1]and $7FFF)))
        or((posv=2)and(ppos^[posv]and $7FFF=align)) then begin // null
        fields^[i]._pvalue:=nil;
        fields^[i]._size:=0;
       end else begin
        if posv=2 then begin
         fields^[i]._pvalue:=pointer(dword(row)+align);
         fields^[i]._size:=(ppos^[posv]and $7FFF)-align;
        end else begin
         fields^[i]._pvalue:=pointer(dword(row)+(ppos^[posv-1]and $7FFF));
         fields^[i]._size:=(ppos^[posv]and $7FFF)-(ppos^[posv-1]and $7FFF);
        end;
        //align:=(ppos^[posv]and $7FFF);
       end;}
      end;
(*     end;
     type_ntext,type_text:begin
      {unknown length}
       fields^[i]._pvalue:=nil;
       fields^[i]._size:=0;
      //exit;*)
     end
    else exit;
    end; {case}
   end;
   result:=true;
  end;
 end;
end;
{---------------------------------------------------------------------}
{$I tables\mdf_header.inc}
{$I tables\mdf_boot.inc}

function mdfInternalTableOpen(q:PmdfPageStream;ptype:byte):PmdfTable;
var pid:TmdfPageId;
    p:PmdfTable;
begin
 result:=nil;p:=nil;
 if q<>nil then begin
  case ptype of
  CmdfPageFileheader: p:=init_mdf_header(p);
  CmdfPageBoot:       p:=init_mdf_boot(p);
 else p:=nil;
 end; {case}
  
  if(p<>nil)and mdfPageGetPageWithIdType(q,id_allocation,ptype,@pid) then with p^ do begin
   if not mdfPageGetPageWithPid(q,@pid,@_page,false) then begin
    mdfTableClose(p);
    exit;
   end;
   _stream:=q;
   _id:=id_allocation;
   _current_row:=0;
   _first_pid:=_page._ph.m_pageId;
   result:=p;
  end;

 end;
end;
{---------------------------------------------------------------------}
function mdfTableOpen(q:PmdfPageStream;id:dword;scan:byte):PmdfTable;
var pid:TmdfPageId;
    p:PmdfTable;
begin
 result:=nil;
 if q<>nil then begin
  p:=MemAlloc(SizeOf(TmdfTable));
  //write('0');
  if(p<>nil)then begin
   //write('1');
   if mdfPageGetPageWithIdType(q,id,CmdfPageData,@pid) then with p^ do begin
    //write('2');
    repeat
     //write('3');
     if not mdfPageGetPageWithPid(q,@pid,@_page,false) then begin
      //write('4');
      mdfTableClose(p);
      exit;
     end;
     pid:=_page._ph.m_prev;
    until mdfPageIdIsNull(@pid);
    _stream:=q;
    _id:=id;
    _current_row:=0;
    _ex:=false;
    _first_pid:=_page._ph.m_pageId;
    _auid._w1:=0;
    _auid._w2:=0;
    _auid._id:=id;
    if scan=1 then _iam:=MemAlloc(SizeOf(TmdfIAM)) else _iam:=nil;
   end;
   result:=p;
   if(p^._iam<>nil)and(mdfPageGetPageWithIdType(q,id,CmdfPageIAM,@pid)) then with p^._iam^ do begin
    _last:=0;
    _lastext:=-1;
    _extent:=false;
    repeat
     if not mdfPageGetPageWithPid(q,@pid,@_page,false) then begin
      MemFree(p^._iam);
      break;
     end;
     _first_pid:=pid;
     pid:=_page._ph.m_prev;
    until mdfPageIdIsNull(@pid);
   end;
  end;
 end;
end;
{---------------------------------------------------------------------}
procedure mdfTableClose(var p:PmdfTable);
//var i:word;
begin
 if p<>nil then with p^ do begin
  if _prow<>nil then MemFree(_prow);
  if _field<>nil then begin
   {if _field_count>0 then // CRASH
    for i:=1 to _field_count do MemFree(_field^[i]._pvalue);}
   MemFree(_field);
  end;
  if _iam<>nil then MemFree(_iam);
  MemFree(p);
 end;
end;
{---------------------------------------------------------------------}
function mdfIAMGetNextLocalExtentNumber(p:PAByte;E:longint;size:word):longint;
var
 L:longint;
 b:byte;
begin
 result:=-1;
 //write('.');
 //--------------------------
 if E=-1 then begin
  L:=0;
  b:=0;
 end else begin
  inc(E);
  b:=byte(E) and 7;
  L:=(E shr 3) and $0FFFF;
 end;
 //--------------------------
 if(p<>nil)and((L+1<size)or((L+1=size)and(b<=7))) then while L<size do begin
  if p^[L+1]=0 then inc(L)
  else begin
   while b<=7 do begin
    if((p^[L+1]shr b)and 1)<>0 then begin
     result:=(L shl 3)or b;
     break;
    end else inc(b);
   end;
   if b>7 then begin
    inc(L);
    b:=0;
   end else break;
  end;
 end;
end;
{---------------------------------------------------------------------}
procedure mdfIAMGetNextPageId(q:PmdfPageStream;iam:PmdfIAM;pid:PmdfPageid);
 var mix:PmdfIAMMix;
     ext:PmdfIAMExt;
begin
 //writeln('Warning. mdfIAMGetNextPageId started');

 pid^._fid:=0;
 pid^._id:=0;
 if iam<>nil then with iam^ do begin
  mix:=@_page._buff[_page._ind[CmdfPageMaxSlots]];
  ext:=@_page._buff[_page._ind[CmdfPageMaxSlots-1]];
  if not _extent then begin
   inc(_last);
   if(_last>8)or(mdfPageIdIsNull(@mix^._pid[_last])) then begin
    _extent:=true;
    _last:=0;
    _lastext:=-1;
   end else pid^:=mix^._pid[_last];
  end;
  if _extent then begin
   if (_lastext>=0)and(_last<7)then inc(_last)
   else begin
    _last:=0;
    _lastext:=mdfIAMGetNextLocalExtentNumber(@ext^._data,_lastext,ext^._size);
    if _lastext=-1 then begin
     _extent:=false;
     _last:=0;
     _lastext:=-1;
     if(mdfPageIdIsNull(@_page._ph.m_next))
      or(not mdfPageGetPageWithPid(q,@_page._ph.m_next,@_page,false))then
      mdfPageGetPageWithPid(q,@_first_pid,@_page,false)
     else mdfIAMGetNextPageId(q,iam,pid);
     exit;
    end;
   end;
   pid^:=mix^._pid[0];
   pid^._id:=pid^._id + dword((_lastext shl 3) or _last);
  end;
 end;
 //writeln('Warning. mdfIAMGetNextPageId ended PID = ',HexStr(pid^._fid,2),':',HexStr(pid^._id,4));
end;
{---------------------------------------------------------------------}
function mdfTableFirstRow(p:PmdfTable):boolean;
 var pid:TmdfPageid;
begin
 result:=false;
 if p<>nil then with p^ do begin
  _current_row:=0;
  if _iam<>nil then with p^._iam^ do begin
   if _first_pid<>_page._ph.m_pageId then
    mdfPageGetPageWithPid(_stream,@_first_pid,@_page,false);
   _last:=0;
   _lastext:=-1;
   _extent:=false;
   mdfIAMGetNextPageId(p^._stream,p^._iam,@pid);
  end else pid:=_first_pid;
  //writeln('Warning. mdfTableFirstRow 1:',pid._fid,':',pid._id,'<=>',
  //         _page._ph.m_pageId._fid,':',_page._ph.m_pageId._id);
  if pid<>_page._ph.m_pageId then
   mdfPageGetPageWithPid(_stream,@pid,@_page,false);
  result:=mdfTableNextRow(p);
 end;
end;
{---------------------------------------------------------------------}
function mdfTableNextRow(p:PmdfTable):boolean;
var rowStart:word;
    oldid:dword;
    nextpid:TmdfPageId;
begin
 //writeln('Warning. mdfTableNextRow 1');
 result:=false;
 if p<>nil then with p^ do begin
  if _prow<>nil then MemFree(_prow);
  repeat
   _rowLength:=0;
   if(_page._ph.m_slotCnt<=_current_row)then begin
    //writeln('Warning. mdfTableNextRow 2');
    oldid:=_page._ph.m_pageId._id;

    {if _iam<>nil then mdfIAMGetNextPageId(p^._iam,@nextpid)
    else nextpid:=_page._ph.m_next;

    while(not mdfPageIdIsNull(@nextpid))and
     (mdfPageGetPageWithPid(_stream,@nextpid,@_page,false))and(_page._ph.m_slotCnt=0) do begin
      if _iam<>nil then mdfIAMGetNextPageId(p^._iam,@nextpid)
      else nextpid:=_page._ph.m_next;
    end;}

    repeat
      if _iam<>nil then mdfIAMGetNextPageId(_stream,_iam,@nextpid)
      else nextpid:=_page._ph.m_next;
      //writeln('.');
      if(not mdfPageIdIsNull(@nextpid))
       and(mdfPageGetPageWithPid(_stream,@nextpid,@_page,false))then begin
        //writeln; // do not remove it - some bug
        if(_page._ph.m_headerVersion=CmdfPageHeader70)
           and(_page._ph.m_type=CmdfPageData)and(oldId<>_page._ph.m_pageId._id)
           and(_page._ph.m_objId=_id)and(_page._ph.m_slotCnt>0)then break;
      end else exit;
      //writeln('Warning. IAM: Next PID = ',HexStr(nextpid._fid,2),':',HexStr(nextpid._id,4),' type = ',_page._ph.m_type)
    until mdfPageIdIsNull(@nextpid);

    {if(_page._ph.m_headerVersion<>CmdfPageHeader70)
      or(_page._ph.m_type<>CmdfPageData)
      or(oldId=_page._ph.m_pageId._id)
      or(_page._ph.m_objId<>_id)
      or(_page._ph.m_slotCnt=0) then exit;}
    //writeln('Warning. mdfTableNextRow 3');
    _current_row:=0;
   end;
   //writeln('Warning. mdfTableNextRow 4');
   rowStart:=_page._ind[CmdfPageMaxSlots-_current_row];
   inc(_current_row);
  until (rowStart>=CmdfPageHeaderSize)
   and(rowStart<=(CmdfPageSize-(_page._ph.m_slotCnt shl 1)-_page._ph.pminlen+1));
  _rowLength:=getRowLength(p,rowStart);
  //writeln('Warning. mdfTableNextRow 5');
  if _rowLength>0 then begin
   //writeln('Warning. mdfTableNextRow 6');
   _prow:=MemAlloc(_rowLength);
   if _prow<>nil then begin
    //writeln('Warning. mdfTableNextRow 7');
    MemCopy(@_page._buff[rowStart],_prow,_rowLength);
    result:=true;
   end;
  end else result:=true;
//  writeln;
 end;
end;
{=====================================================================}
function getFieldNumber(tab:PmdfTable;field_name:string):word;
var
 i:word;
begin
 result:=0;
 if(tab<>nil)then with tab^ do begin
  for i:=1 to _field_count do
   if(_field^[i]._pname<>nil)and(PStr(_field^[i]._pname)^=field_name)then begin
    result:=i;
    break;
   end;
 end;
end;

function getFieldName(tab:PmdfTable;field_number:word):string;
begin
 result:='';
 if tab<>nil then with tab^ do begin
  if(field_number>0)and(field_number<=_field_count)
   and(_field^[field_number]._pname<>nil)then
   result:=PStr(_field^[field_number]._pname)^;
 end;
end;

function mdfTableInitFromTable(p:PmdfTable):boolean;
var
 tabSyscolumns:PmdfTable;
 q,q1:PmdfTableFields;
 objId,ColCnt,ColMax:dword;
 s:string;
begin
 result:=false;
 if(p<>nil)and(p^._stream<>nil)then begin
  objId:=p^._id;
  ColCnt:=0;ColMax:=0;
  tabSyscolumns:=mdfTableOpen(p^._stream,id_Syscolumns,0);
  if tabSyscolumns<>nil then begin
   mdfSysTablesInitTable(tabSyscolumns,id_Syscolumns);
   if mdfTableFirstRow(tabSyscolumns)then begin
    repeat
     if mdfTableRowParse(tabSyscolumns) then begin
      if(tabSyscolumns^._field^[2]._pvalue<>nil)and
       (dword(tabSyscolumns^._field^[2]._pvalue^)=objId)then begin
       inc(ColCnt);
       if(dword(tabSyscolumns^._field^[9]._pvalue^)>ColMax)then
        ColMax:=dword(word(tabSyscolumns^._field^[9]._pvalue^));
      end;
     end;
    until not mdfTableNextRow(tabSyscolumns);
   end;
   if{(ColMax=ColCnt)and}(ColCnt>0)and(mdfTableFirstRow(tabSyscolumns))then begin
    q:=MemAlloc(ColCnt*sizeof(TmdfTableField));
    if q<>nil then begin
     p^._field_count:=ColCnt;
     p^._field:=q;
     ColCnt:=0;
     repeat
      if mdfTableRowParse(tabSyscolumns) then begin
       if(tabSyscolumns^._field^[2]._pvalue<>nil)and
        (tabSyscolumns^._field^[1]._pvalue<>nil)and
        (tabSyscolumns^._field^[1]._size>0)and
        (tabSyscolumns^._field^[3]._pvalue<>nil)and
        (tabSyscolumns^._field^[6]._pvalue<>nil)and
        (tabSyscolumns^._field^[9]._pvalue<>nil)and
        (dword(tabSyscolumns^._field^[2]._pvalue^)=objId)then begin

        inc(ColCnt);
        byte(s[0]):=tabSyscolumns^._field^[1]._size shr 1;
        UnicodeToStr(tabSyscolumns^._field^[1]._pvalue,@s[1],byte(s[0]));

        mdfTableFieldInit(q^[ColCnt],
         byte(dword(tabSyscolumns^._field^[3]._pvalue^)),
         word(dword(tabSyscolumns^._field^[6]._pvalue^)),s);
       end;
      end;
     until not mdfTableNextRow(tabSyscolumns);
     result:=true;
    end;
   end;
  end;
 end;
end;
{=====================================================================}
function mdfTableInitFromTableEx(p:PmdfTable):boolean;
var
 tabSyscolumns:PmdfTable;
 q,q1:PmdfTableFields;
 objId,ColCnt,ColMax:dword;
 s:string;
begin
 result:=false;
 if(p<>nil)and(p^._stream<>nil)then begin
  objId:=p^._id;
  ColCnt:=0;ColMax:=0;
  tabSyscolumns:=mdfTableOpenEx(p^._stream,id_Syscolumns,0);
  if tabSyscolumns<>nil then begin
   mdfSysTablesInitTable(tabSyscolumns,id_Syscolumns);
   if mdfTableFirstRow(tabSyscolumns)then begin
    repeat
     //write('.');
     if mdfTableRowParse(tabSyscolumns) then begin
      //write('!');
       if(tabSyscolumns^._field^[2]._pvalue<>nil)and
        (dword(tabSyscolumns^._field^[2]._pvalue^)=objId)then begin
        inc(ColCnt);
        //writeln(dword(tabSyscolumns^._field^[9]._pvalue^),':',word(tabSyscolumns^._field^[9]._pvalue^));
        if(word(tabSyscolumns^._field^[9]._pvalue^)>ColMax)then
         ColMax:=dword(word(tabSyscolumns^._field^[9]._pvalue^));
      end;
     end;
    until not mdfTableNextRow(tabSyscolumns);
   end;
   if{(ColMax=ColCnt)and}(ColCnt>0)and(mdfTableFirstRow(tabSyscolumns))then begin
    q:=MemAlloc(ColCnt*sizeof(TmdfTableField));
    if q<>nil then begin
     p^._field_count:=ColCnt;
     p^._field:=q;
     ColCnt:=0;
     repeat
      if mdfTableRowParse(tabSyscolumns) then begin
       if(tabSyscolumns^._field^[2]._pvalue<>nil)and
         (tabSyscolumns^._field^[9]._pvalue<>nil)and
         (dword(tabSyscolumns^._field^[2]._pvalue^)=objId)then begin
        inc(ColCnt);
        if(tabSyscolumns^._field^[1]._pvalue<>nil)and
          (tabSyscolumns^._field^[1]._size>0)and
          (tabSyscolumns^._field^[3]._pvalue<>nil)and
          (tabSyscolumns^._field^[6]._pvalue<>nil)then begin

         byte(s[0]):=tabSyscolumns^._field^[1]._size shr 1;
         UnicodeToStr(tabSyscolumns^._field^[1]._pvalue,@s[1],byte(s[0]));

         mdfTableFieldInit(q^[ColCnt],
          byte(dword(tabSyscolumns^._field^[3]._pvalue^)),
          word(dword(tabSyscolumns^._field^[6]._pvalue^)),s);
        end;
        //------------------------------------------------------
        if(tabSyscolumns^._field^[5]._pvalue<>nil)and
         (tabSyscolumns^._field^[5]._size>0)then
          q^[ColCnt]._xusertype:=word(tabSyscolumns^._field^[5]._pvalue^);
        if(tabSyscolumns^._field^[7]._pvalue<>nil)and
         (tabSyscolumns^._field^[7]._size>0)then
          q^[ColCnt]._xprec:=byte(tabSyscolumns^._field^[7]._pvalue^);
        if(tabSyscolumns^._field^[8]._pvalue<>nil)and
         (tabSyscolumns^._field^[8]._size>0)then
          q^[ColCnt]._xscale:=byte(tabSyscolumns^._field^[8]._pvalue^);
        if(tabSyscolumns^._field^[10]._pvalue<>nil)and
         (tabSyscolumns^._field^[10]._size>0)then
          q^[ColCnt]._xoffset:=word(tabSyscolumns^._field^[10]._pvalue^);
        if(tabSyscolumns^._field^[11]._pvalue<>nil)and
         (tabSyscolumns^._field^[11]._size>0)then
          q^[ColCnt]._bitpos:=byte(tabSyscolumns^._field^[11]._pvalue^);
        if(tabSyscolumns^._field^[9]._pvalue<>nil)and
         (tabSyscolumns^._field^[9]._size>0)then
          q^[ColCnt]._colid:=word(tabSyscolumns^._field^[9]._pvalue^);
        if(tabSyscolumns^._field^[4]._pvalue<>nil)and
         (tabSyscolumns^._field^[4]._size>0)then
          q^[ColCnt]._typestat:=byte(tabSyscolumns^._field^[4]._pvalue^);
        if(tabSyscolumns^._field^[13]._pvalue<>nil)and
         (tabSyscolumns^._field^[13]._size>0)then
          q^[ColCnt]._colstat:=word(tabSyscolumns^._field^[13]._pvalue^);
        //------------------------------------------------------
       end;
      end;
     until not mdfTableNextRow(tabSyscolumns);
     result:=true;
    end;
   end;
  end else writeln('Warning. mdfTableInitFromTableEx->mdfTableOpenEx(syscolumns): error');
 end;
end;
{=====================================================================}
function mdfTableInitFromTableEx2(p:PmdfTable):boolean;
var
 tab:PmdfTable;
 q,q1:PmdfTableFields;
 id,objId,ColCnt:dword;
 s:string;
 i,f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12:word;
begin
 //write('Warning. mdfTableInitFromTableEx2');
 result:=false;
 //write(' 1');
 if(p<>nil)and(p^._stream<>nil)then begin
  objId:=p^._id;
  ColCnt:=0;

  for i:=1 to PmdfUnionTables(p^._stream^._columns)^.t_cnt do begin
   id:=PmdfUnionTables(p^._stream^._columns)^.t[i].t_id;
   tab:=mdfTableOpenEx(p^._stream,id,0);
   if tab=nil then writeln('Warning. Can''t open table # ',id,'; ver. ',p^._stream^._version)
   else begin

    mdfSysTablesInitTable(tab,id);

    f1:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[1]);
    //writeln(1,#9,f1,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[1]);
    f2:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[2]);
    //writeln(2,#9,f2,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[2]);
    f3:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[3]);
    //writeln(3,#9,f3,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[3]);
    f4:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[4]);
    //writeln(4,#9,f4,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[4]);
    f5:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[5]);
    //writeln(5,#9,f5,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[5]);

    f6:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[6]);
    //writeln(6,#9,f6,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[6]);
    f7:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[7]);
    //writeln(7,#9,f7,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[7]);
    f8:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[8]);
    //writeln(8,#9,f8,#9,PmdfUnionTables(p^._stream^._columns)^.t[i].f[8]);

    if PmdfUnionTables(p^._stream^._columns)^.t[i].f_cnt>8 then begin 
     f9:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[9]);
     f10:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[10]);
     f11:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[11]);
     f12:=getFieldNumber(tab,PmdfUnionTables(p^._stream^._columns)^.t[i].f[12]);
    end else begin
     f9:=0;
     f10:=0;
     f11:=0;
     f12:=0;
    end;
    if(f1>0)and(f2>0)and(f3>0)and(f4>0)and(f5>0)
    and(mdfTableFirstRow(tab))then begin
     repeat
      if mdfTableRowParse(tab) then begin
       if(tab^._field^[f1]._pvalue<>nil)and
        (dword(tab^._field^[f1]._pvalue^)=objId)then
        inc(ColCnt);
      end;
     until not mdfTableNextRow(tab);
    end;
    if(ColCnt>0)and(mdfTableFirstRow(tab))then begin
     q:=MemAlloc(ColCnt*sizeof(TmdfTableField));
     if q<>nil then begin
      p^._field_count:=ColCnt;
      p^._field:=q;
      ColCnt:=0;
      result:=true;
      repeat
       if mdfTableRowParse(tab) then begin
        if(tab^._field^[f1]._pvalue<>nil)and
          (dword(tab^._field^[f1]._pvalue^)=objId)then begin
         inc(ColCnt);
         if(tab^._field^[f2]._pvalue<>nil)and
           (tab^._field^[f2]._size>0)and
           (tab^._field^[f3]._pvalue<>nil)and
           (tab^._field^[f4]._pvalue<>nil)then begin

          byte(s[0]):=tab^._field^[f2]._size shr 1;
          UnicodeToStr(tab^._field^[f2]._pvalue,@s[1],byte(s[0]));

          mdfTableFieldInit(q^[ColCnt],
           byte(dword(tab^._field^[f3]._pvalue^)),
           word(dword(tab^._field^[f4]._pvalue^)),s);
         end;
         //writeln(ColCnt,#9,s);
         //------------------------------------------------------
         if(tab^._field^[f5]._pvalue<>nil)and(tab^._field^[f5]._size>0)then
           q^[ColCnt]._colid:=word(tab^._field^[f5]._pvalue^);
         if(tab^._field^[f6]._pvalue<>nil)and(tab^._field^[f6]._size>0)then
           q^[ColCnt]._xusertype:=word(tab^._field^[f6]._pvalue^);
         if(tab^._field^[f7]._pvalue<>nil)and(tab^._field^[f7]._size>0)then
           q^[ColCnt]._xprec:=byte(tab^._field^[f7]._pvalue^);
         if(tab^._field^[f8]._pvalue<>nil)and(tab^._field^[f8]._size>0)then
           q^[ColCnt]._xscale:=byte(tab^._field^[f8]._pvalue^);

         if PmdfUnionTables(p^._stream^._columns)^.t[i].f_cnt>8 then begin 
          if(tab^._field^[f9]._pvalue<>nil)and(tab^._field^[f9]._size>0)then
            q^[ColCnt]._xoffset:=word(tab^._field^[f9]._pvalue^);
          if(tab^._field^[f10]._pvalue<>nil)and(tab^._field^[f10]._size>0)then
            q^[ColCnt]._bitpos:=byte(tab^._field^[f10]._pvalue^);
          if(tab^._field^[f11]._pvalue<>nil)and(tab^._field^[f11]._size>0)then
            q^[ColCnt]._typestat:=byte(tab^._field^[f11]._pvalue^);
          if(tab^._field^[f12]._pvalue<>nil)and(tab^._field^[f12]._size>0)then
            q^[ColCnt]._colstat:=word(tab^._field^[f12]._pvalue^);
         end;
         //------------------------------------------------------
        end;
       end;
      until not mdfTableNextRow(tab);
     end;
    end;
    mdfTableClose(tab);
   end;
   if result then break;
  end; {for}
 end;
 //readln;
end;
{=====================================================================}

{$I tables\sysobjects.inc}
{$I tables\sysindexes.inc}
{$I tables\syscolumns.inc}
{$I tables\systypes.inc}
{$I tables\sysusers.inc}
//9.0
{$I tables\sysschobjs.inc}
{$I tables\sysclsobjs.inc}
{$I tables\sysbinobjs.inc}
{$I tables\sysnsobjs.inc}
{$I tables\systypedsubobjs.inc}
{$I tables\syscolpars.inc}
{$I tables\sysallocunits.inc}
{$I tables\sysrowsets.inc}

function mdfSysTablesInitTable(p:PmdfTable;id:dword):PmdfTable;
begin
 case id of

  //id_system_objects,
  id_sysobjects        : result := init_sysobjects(p,id);
  id_sysindexes        : result := init_sysindexes(p);
  id_syscolumns        : result := init_syscolumns(p);
  id_systypes          : result := init_systypes(p);
  id_sysusers          : result := init_sysusers(p);

  id_sysschobjs        : result := init_sysschobjs(p);
  id_sysclsobjs        : result := init_sysclsobjs(p);
  id_sysbinobjs        : result := init_sysbinobjs(p);
  id_sysnsobjs         : result := init_sysnsobjs(p);
  id_systypedsubobjs   : result := init_systypedsubobjs(p);
  id_syscolpars        : result := init_syscolpars(p);
  id_sysallocunits     : result := init_sysallocunits(p);
  id_sysrowsets        : result := init_sysrowsets(p);


 else result:=nil;
 end; {case}
end;
{=====================================================================}
function mdfTableOpenEx(q:PmdfPageStream;id:dword;scan:byte):PmdfTable;
var pid:TmdfPageId;
    p:PmdfTable;
    tab:PmdfTable;
    p1:pointer;
    i,sysid:integer;
    rsid,rcnt:qword;
    aid:dword;
begin
 //write('Warning. mdfTableOpenEx id = ',id,';');
 result:=nil;
 if q<>nil then begin
  p:=MemAlloc(SizeOf(TmdfTable));
  if(p<>nil)then begin
   if q^._version>80 then begin
    //write(' 1');
    sysid:=id_sysallocunits;
    rsid:=0;
    tab:=mdfTableOpen(q,id_sysrowsets,0);
    if tab<>nil then begin
     //write(' 2');
     mdfSysTablesInitTable(tab,id_sysrowsets);
     if mdfTableFirstRow(tab)then begin
      //write(' 3');
      repeat
       if mdfTableRowParse(tab) then begin
        with tab^ do begin
         if(_field^[3]._pvalue<>nil)and(pdword(_field^[3]._pvalue)^=id)
           and(_field^[1]._pvalue<>nil)then begin
          //write(' 4');
          MemCopy(_field^[1]._pvalue,@rsid,8);
          if(_field^[8]._pvalue<>nil)then
           MemCopy(_field^[8]._pvalue,@rcnt,8);
          break;
         end;
        end;
       end;
      until not mdfTableNextRow(tab);
     end;
     mdfTableClose(tab);
    end;
   end else sysid:=id_sysindexes;
   if(q^._version<=80)or(rsid<>0) then
    tab:=mdfTableOpen(q,sysid,0);
   if tab<>nil then begin
    //write(' 5');
    mdfSysTablesInitTable(tab,sysid);
    if mdfTableFirstRow(tab)then begin
     repeat
      if mdfTableRowParse(tab) then begin
       with tab^ do begin
       //write('.');
       if((q^._version>80)and
         (_field^[3]._pvalue<>nil)and(pqword(_field^[3]._pvalue)^=rsid)
         and(_field^[2]._pvalue<>nil)and(pbyte(_field^[2]._pvalue)^ in [0,1])
         and(_field^[6]._pvalue<>nil)and(_field^[1]._pvalue<>nil))
         or((q^._version<=80)and
         (_field^[1]._pvalue<>nil)and(pdword(_field^[1]._pvalue)^=id)
         and(_field^[4]._pvalue<>nil)and(pword(_field^[4]._pvalue)^ in [0,1])
         and(_field^[3]._pvalue<>nil))

          then begin
          p^._auid._w1:=0;
          p^._auid._w2:=0;
          p^._auid._id:=id;

          if q^._version>80 then begin
           MemCopy(_field^[1]._pvalue,@p^._auid,8);
           MemCopy(_field^[6]._pvalue,@pid,6);
           p^._clustered:=false;
          end else begin
           MemCopy(_field^[3]._pvalue,@pid,6);
           p^._clustered:=boolean(tab^._field^[4]._pvalue^);
           if(_field^[12]._pvalue<>nil)then
            MemCopy(_field^[12]._pvalue,@rcnt,8)
           else rcnt:=0;
          end;
          aid:=p^._auid._id;
          //----------------
          //p1:=@tab^._page;
          //for i:=0 to 5 do begin
          // writeln('  ',HexStr(i shl 4,1),': ',HexStr(p1,16,' ',1,0));
          // inc(p1,16);
          //end;
          //writeln('mdfTableOpenEx:');
          //writeln('   id = ',HexStr(dword(_field^[1]._pvalue^),4));
          //writeln('indid = ',HexStr(word(_field^[4]._pvalue^),2));
          //writeln('1-st1 = ',HexStr(pid._fid,2),':',HexStr(pid._id,4));
          //writeln('Warning. First PID = ',HexStr(pid._fid,2),':',HexStr(pid._id,4));
          //----------------
          if(not mdfPageIdIsNull(@pid))and((not mdfPageGetPageWithPid(q,@pid,@(p^._page),false))
           or(p^._page._ph.m_objId<>aid))then begin
           //writeln('mdfPageGetPageWithPid: error');
           if not mdfPageGetPageWithIdType(q,aid,CmdfPageData,@pid)then begin
            mdfTableClose(p);
            writeln(#13,'Warning. mdfPageGetPageWithIdType: error; exit');
            exit;
           end;
          end;
          repeat
           if not mdfPageGetPageWithPid(q,@pid,@(p^._page),false) then begin
            mdfTableClose(p);
            writeln(#13,'Warning. mdfPageGetPageWithPid: error; exit');
            exit;
           end;
           pid:=p^._page._ph.m_prev;
           //writeln('1-stN = ',HexStr(pid._fid,2),':',HexStr(pid._id,4));
          until mdfPageIdIsNull(@pid);

          if(q^._version<=80)and(_field^[21]._pvalue<>nil)then
           MemCopy(_field^[21]._pvalue,@pid,6)
          else if(q^._version>80)and(_field^[8]._pvalue<>nil)then
           MemCopy(_field^[8]._pvalue,@pid,6)
          else begin
           pid._id:=0;
           pid._fid:=0;
          end;
          //writeln('Warning. First IAM = ',HexStr(pid._fid,2),':',HexStr(pid._id,4));
          with p^ do begin
           _stream:=q;
           _id:=id;
           _current_row:=0;
           _first_pid:=_page._ph.m_pageId;
           _rowCnt:=rcnt;
           _ex:=(q^._version<=80);
          //writeln('1-st2 = ',HexStr(_first_pid._fid,2),':',HexStr(_first_pid._id,4));
           if(scan=1)and(not mdfPageIdIsNull(@pid))then
            _iam:=MemAlloc(SizeOf(TmdfIAM)) else _iam:=nil;
          end;

          //------------------------------------------------------------------

          if(p^._iam<>nil)and((not mdfPageIdIsNull(@pid))
             or(mdfPageGetPageWithIdType(q,id,CmdfPageIAM,@pid))) then with p^._iam^ do begin
            _last:=0;
            _lastext:=-1;
            _extent:=false;
            repeat
             if not mdfPageGetPageWithPid(q,@pid,@_page,false) then begin
              MemFree(p^._iam);
              break;
             end;
             _first_pid:=pid;
             pid:=_page._ph.m_prev;
           until mdfPageIdIsNull(@pid);
          end;

          result:=p;
          break;
        end;
       end;
      end;
     until not mdfTableNextRow(tab);
    end;
    mdfTableClose(tab);
   end;
   if result=nil then begin
    MemFree(p);
    //write('5');
    result:=mdfTableOpen(q,id,scan);
   end;
  end;
 end;
 //writeln(' end');
end;
{=====================================================================}
procedure mdfGetBlob(p:PmdfPageStream;b:PmdfBlobLink;var blob:TmdfBlob);
var
 page:TmdfPage;

procedure getBlob;
 var
  brow:PByte;
  bsize,dsize,i:word;
  btype:byte;
  q:pointer;
 begin
  //writeln('pid=',HexStr(b^._pid._id,4),':',HexStr(b^._pid._fid,2),'; slot=',HexStr(b^._slot,2));
  if(mdfPageGetPageWithPid(p,@b^._pid,@page,false))and(page._ph.m_slotCnt>b^._slot)then begin
   brow:=@page._buff[page._ind[CmdfPageMaxSlots-b^._slot]];
   if pword(brow)^<>8 then exit;
   inc(brow,2);
   bsize:=pword(brow)^;
   inc(brow,2);
   if pqword(brow)^<>b^._blobId then exit;
   inc(brow,8);
   btype:=brow^ and $0F;
   inc(brow,2);
   case btype of
    0,3: with blob do begin
        if btype=0 then begin
         dsize:=pword(brow)^;
         inc(brow,6);
        end else begin
         dsize:=bsize-14;
        end;
        q:=MemAlloc(_size+dsize);
        if q<>nil then begin
         if _pvalue<>nil then begin
          MemCopy(_pvalue,q,_size);
          MemFree(_pvalue);
         end;
         _pvalue:=q;
         inc(q,_size);
         MemCopy(brow,q,dsize);
         inc(_size,dsize);
        end;
       end;
     4:begin
        q:=MemAlloc(bsize-14);
        if q<>nil then begin
         MemCopy(brow,q,bsize-14);
         brow:=q;
         inc(brow,10);
         for i:=1 to PAWord(q)^[2]do begin
          inc(brow,4);              //skip size
          MemCopy(brow,@b^._pid,8); //pid and slot
          getBlob;
          inc(brow,8);              //next slot
         end;
         MemFree(q);
        end;
       end
    else begin
     writeln('Warning. Unsupported blob type 0x'+HexStr(btype,1));
    end;
   end; {case}
  end;
 end;

begin
 with blob do begin
  if _pvalue<>nil then MemFree(_pvalue);
  _size:=0;
 end;
 if p=nil then exit;
 getBlob;
end;
{=====================================================================}
end.
