{2006.04.02 - 1.4}
{2005.05.11 - 1.3}
{2005.03.08 - 1.2}
{2005.02.28 - 1.1}
{2005.02.27 - 1.0}
program mdfr;
uses plMem,plFile64,plStr,plUni,plOem,plType,{mdfSTbls,}
     mdfType,mdfTable,mdfPage{,sysutils},plSQLTime,mtfDrv,mtfLoc{,math};

const
 sZeroTime = '0000-00-00 00:00:00.000';
 sNullGuid = '00000000-0000-0000-0000-000000000000';
 sNullLsn  = '0:0:0';

var
 fname:string; {mdf-file name}
 fullname,objname:string;
 cmd:char;     {command}
 vrb:boolean;
 f:longint;
 tab:PmdfTable;
 pageStream:PmdfPageStream;
 s,s1:string;
 i,j:integer;
 objId:dword;
 date4:TDate4;
 date8:TDate8;
 sqltime:TSQLTime;
 p:pointer;
 L:dword;
 start,size:Int64;
 oper:byte;
 pMtf:PmtfDevice;
 out:text;

procedure die(msg:string);
begin
 if vrb then writeln(msg);
 halt(1);
end;

procedure ParseCmdLine;
var
 s:string;
begin
 {----------------------------}
 vrb:=true; cmd:=#0; fname:=''; objname:='';
 {----------------------------}
 if ParamCount>1 then begin
  s:=ParamStr(1);
  byte(cmd):=byte(s[1])or$20;
  fname:=ParamStr(2);
  if(cmd in['x','e'])and(ParamCount>2)then objname:=ParamStr(3);
 end;
 {----------------------------}
 if(cmd=#0)or(fname='')or((cmd in['x','e'])and(ParamCount<3))then begin
  writeln;
  writeln('Usage: mdfr <command> <filename> [<object name>]');
  writeln;
  writeln(#9'Commands:');
  writeln;
  writeln(#9'l   list objects');
  writeln(#9'e   extract object');
  writeln(#9'x   extract object with full path');
  writeln;
  die('');
 end;
end;

function GUID2Str(p:pointer):string;
begin
 if(p=nil)then result:=sNullGuid else begin
  result:=HexStr(p,4,'',1,1)+'-'+HexStr(@paword(p)^[3],2,'',1,1)+'-'
   +HexStr(@paword(p)^[4],2,'',1,1)+'-'+HexStr(@paword(p)^[5],2,'',1,0)+'-'
   +HexStr(@paword(p)^[6],6,'',1,0);
 end;
end;

function Size2Str(size:Int64):string;
var i:byte;
    w:word;
    s:string;
begin
  i:=0;
  w:=0;
  while(size<>0)and(i<4)and(((not Int64($3FF))and size)<>0) do begin
   //writeln(i,':',((not Int64($3FF))and size),':',size);
   w:=$3FF and word(size);
   size:=size shr 10;
   inc(i);
  end;
  w:=(w*100)div 1024;
  //writeln(i,':',((not Int64($3FF))and size),':',size,':',w);
  Str(word(size),result);
  if w>0 then begin
   Str(w,s);
   result+='.'+s;
  end;
  case i of
   0:result+=' B';
   1:result+=' KB';
   2:result+=' MB';
   3:result+=' GB'
  else result+=' TB';
  end;
end;

function LSN2Str(p:PmdfPageLSN):string;
var s:string;
begin
 if p<>nil then begin
 Str(p^.d1,result);
 Str(p^.d2,s);
 result+=':'+s;
 Str(p^.w1,s);
 result+=':'+s;
 end else result:=sNullLsn;
end;

function EscapeStr(var p:pointer;var L:dword):string;
begin
 result:='';
 while(L>0)and(byte(result[0])<252)do begin
  case pbyte(p)^ of
   $07: result+='\a';
   $08: result+='\b';
   $09: result+='\t';
   $0A: result+='\n';
   $0B: result+='\v';
   $0C: result+='\f';
   $0D: result+='\r';
   $22: result+='\"';
   $5C: result+='\\';
  else
   if(pbyte(p)^>=32)then
    result+=char(pbyte(p)^)
   else result+='\x'+HexStr(dword(p^),1);
  end; {case}
  dec(L);
  inc(p);
 end;
end;

{$I mdfr.inc}

(*function getObjId(objname:string;pageStream:PmdfPageStream):dword;
var
 tabSysobjects:PmdfTable;
 s:string;
begin
 result:=0;
 tabSysobjects:=mdfTableOpenEx(pageStream,id_sysobjects);
 if tabSysobjects<>nil then begin
  mdfSysTablesInitTable(tabSysobjects,id_sysobjects);
  if mdfTableFirstRow(tabSysobjects)then begin
   repeat
    if mdfTableRowParse(tabSysobjects) then begin
     {------------------------------------------------------------}
     with tabSysobjects^ do begin
      if(_field^[1]._pvalue<>nil)and(_field^[1]._size<>0)then begin
       byte(s[0]):=_field^[1]._size shr 1;
       UnicodeToStr(_field^[1]._pvalue,@s[1],byte(s[0]));
      end else s:='<NULL>';
      if(s=objname){and(_field^[3]._pvalue<>nil)and(word(_field^[3]._pvalue^)in[obj_S,obj_U])}
       and(_field^[2]._pvalue<>nil)then begin
        result:=dword(_field^[2]._pvalue^);
        break;
      end;
     end;
    end;
   until not mdfTableNextRow(tabSysobjects);
  end;
  mdfTableClose(tabSysobjects);
 end;
end;*)

procedure printDBInfo(var out:text;pageStream:PmdfPageStream);
var
 tab:PmdfTable;
 L,status:dword;
 s:string;
 sqltime:TSQLTime;
begin
 tab:=mdfInternalTableOpen(pageStream,CmdfPageFileheader);
 if(tab<>nil)then begin
  if(mdfTableFirstRow(tab))then begin
   if(mdfTableRowParse(tab)) then with tab^ do begin

    if(_field^[14]._pvalue<>nil) then status:=longint(_field^[14]._pvalue^);

    writeln(out);
    writeln(out,' Header');
    writeln(out,' ======');
    writeln(out);
    if(_field^[1]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[1]._pname^),25,0),' : ',GUID2Str(_field^[1]._pvalue));
    if(_field^[2]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[2]._pname^),25,0),' : ',
      '0x',HexStr(_field^[2]._pvalue,_field^[2]._size,'',1,0));
    if(_field^[3]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[3]._pname^),25,0),' : ',smallint(_field^[3]._pvalue^));
    if(_field^[4]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[4]._pname^),25,0),' : ',smallint(_field^[4]._pvalue^));
    // size
    if(_field^[5]._pvalue<>nil)then begin
     L:=dword(_field^[5]._pvalue^);
     write(out,' '+DopSpace(string(_field^[5]._pname^),25,0),' : ');
     //write(out,'0x',HexStr(L,4),' => ');
     writeln(out,Size2Str(Int64(L)*CmdfPageSize));
    end;
    //maxsize
    if(_field^[6]._pvalue<>nil)then begin
     L:=dword(_field^[6]._pvalue^);
     write(out,' '+DopSpace(string(_field^[6]._pname^),25,0),' : ');
     //write(out,'0x',HexStr(L,4),' => ');
     if L=dword(-1) then writeln(out,'Not defined')
     else writeln(out,Size2Str(Int64(L)*CmdfPageSize));
    end;
    //growth
    if(_field^[7]._pvalue<>nil)then begin
     L:=dword(_field^[7]._pvalue^);
     write(out,' '+DopSpace(string(_field^[7]._pname^),25,0),' : ');
     //write(out,'0x',HexStr(L,4),' => ');
     if L=0 then writeln(out,'Not defined') else
      if(status and $100000)<>0 then writeln(out,L,'%')
      else writeln(out,Size2Str(Int64(L)*CmdfPageSize));
    end;

    if(_field^[8]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[8]._pname^),25,0),' : ',longint(_field^[8]._pvalue^));
    if(_field^[9]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[9]._pname^),25,0),' : ',LSN2Str(_field^[9]._pvalue));
    if(_field^[10]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[10]._pname^),25,0),' : ',LSN2Str(_field^[10]._pvalue));
    if(_field^[11]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[11]._pname^),25,0),' : ',LSN2Str(_field^[11]._pvalue));
    if(_field^[12]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[12]._pname^),25,0),' : ',LSN2Str(_field^[12]._pvalue));
    //minsize
    if(_field^[13]._pvalue<>nil)then begin
     L:=dword(_field^[13]._pvalue^);
     write(out,' '+DopSpace(string(_field^[13]._pname^),25,0),' : ');
     //write(out,'0x',HexStr(L,4),' => ');
     if L=dword(-1) then writeln(out,'Not defined')
     else writeln(out,Size2Str(Int64(L)*CmdfPageSize));
    end;
    //status
    writeln(out,' '+DopSpace(string(_field^[14]._pname^),25,0),' : 0x',HexStr(status,4));
    //shrink
    if(_field^[15]._pvalue<>nil)then begin
     L:=dword(_field^[15]._pvalue^);
     write(out,' '+DopSpace(string(_field^[15]._pname^),25,0),' : ');
     //write(out,'0x',HexStr(L,4),' => ');
     if L=dword(-1) then writeln(out,'Not defined')
     else writeln(out,Size2Str(Int64(L)*CmdfPageSize));
    end;

    if(_field^[16]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[16]._pname^),25,0),' : ',longint(_field^[16]._pvalue^));
    if(_field^[17]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[11]._pname^),25,0),' : ',LSN2Str(_field^[17]._pvalue));
    if(_field^[18]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[18]._pname^),25,0),' : ',
      '0x',HexStr(_field^[18]._pvalue,_field^[18]._size,'',1,0));
    if(_field^[19]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[12]._pname^),25,0),' : ',LSN2Str(_field^[19]._pvalue));

    writeln(out);

    if(_field^[20]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[20]._pname^),25,0),' : ',LSN2Str(_field^[20]._pvalue));
    if(_field^[21]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[21]._pname^),25,0),' : ',LSN2Str(_field^[21]._pvalue));
    if(_field^[22]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[22]._pname^),25,0),' : ',GUID2Str(_field^[22]._pvalue));

    writeln(out);

    if(_field^[23]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[23]._pname^),25,0),' : ',LSN2Str(_field^[23]._pvalue));
    if(_field^[24]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[24]._pname^),25,0),' : ',GUID2Str(_field^[24]._pvalue));
    if(_field^[25]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[25]._pname^),25,0),' : ',
      '0x',HexStr(_field^[25]._pvalue,_field^[25]._size,'',1,0));
    if(_field^[26]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[26]._pname^),25,0),' : ',LSN2Str(_field^[26]._pvalue));
    if(_field^[27]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[27]._pname^),25,0),' : ',
      '0x',HexStr(_field^[27]._pvalue,_field^[27]._size,'',1,0));
    if(_field^[28]._pvalue<>nil) then begin
     byte(s[0]):=byte(_field^[28]._size)shr 1;
     UnicodeToStr(_field^[28]._pvalue,@s[1],byte(s[0]));
     writeln(out,' '+DopSpace(string(_field^[28]._pname^),25,0),' : ',s);
    end;
    if(_field^[29]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[29]._pname^),25,0),' : ',GUID2Str(_field^[22]._pvalue));

   end {with} else writeln('Warning. Can''t parse row [header]');
  end else writeln('Warning. Can''t get 1-st row [header]');
  mdfTableClose(tab);
 end else writeln('Warning. Can''t initialise table [header]');
 {----------------------------------------------------------------------}
 tab:=mdfInternalTableOpen(pageStream,CmdfPageBoot);
 if(tab<>nil)then begin
  if(mdfTableFirstRow(tab))then begin
   if(mdfTableRowParse(tab)) then with tab^ do begin

    writeln(out);
    writeln(out,' Boot (size = 0x',HexStr(_rowLength,2),')');
    writeln(out,' ====================');
    writeln(out);

    if(_field^[1]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[1]._pname^),25,0),' : ',
      '0x',HexStr(_field^[1]._pvalue,_field^[1]._size,'',1,1));
    if(_field^[2]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[2]._pname^),25,0),' : ',
      '0x',HexStr(_field^[2]._pvalue,_field^[2]._size,'',1,1));
    {if(_field^[3]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[3]._pname^),25,0),' : ',
      '0x',HexStr(_field^[3]._pvalue,_field^[3]._size,'',1,0));}
    if(_field^[4]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[4]._pname^),25,0),' : ',
      '0x',HexStr(_field^[4]._pvalue,_field^[4]._size,'',1,1));

    {if(_field^[5]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[5]._pname^),25,0),' : ',
      '0x',HexStr(_field^[5]._pvalue,_field^[5]._size,'',1,0));
    if(_field^[6]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[6]._pname^),25,0),' : ',
      '0x',HexStr(_field^[6]._pvalue,_field^[6]._size,'',1,0));
    if(_field^[7]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[7]._pname^),25,0),' : ',
      '0x',HexStr(_field^[7]._pvalue,_field^[7]._size,'',1,0));}
    if(_field^[8]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[8]._pname^),25,0),' : ',
      '0x',HexStr(_field^[8]._pvalue,_field^[8]._size,'',1,1));
    if(_field^[9]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[9]._pname^),25,0),' : ',
      '0x',HexStr(_field^[9]._pvalue,_field^[9]._size,'',1,1));
    if(_field^[10]._pvalue<>nil) then begin
     ConvertToSystime(_field^[10]._pvalue,@sqltime);
     writeln(out,' '+DopSpace(string(_field^[10]._pname^),25,0),' : ',SystimeToStr(@sqltime,true));
    end;
    if(_field^[11]._pvalue<>nil)and(_field^[12]._pvalue<>nil)
    and(longint(_field^[12]._pvalue^)>1)then begin
     if(longint(_field^[12]._pvalue^)>256)then byte(s[0]):=128
     else byte(s[0]):=byte(_field^[12]._pvalue^)shr 1;
     UnicodeToStr(_field^[11]._pvalue,@s[1],byte(s[0]));
     writeln(out,' '+DopSpace(string(_field^[11]._pname^),25,0),' : "',s,'"');
    end;
    if(_field^[13]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[13]._pname^),25,0),' : ',smallint(_field^[13]._pvalue^));
    if(_field^[14]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[14]._pname^),25,0),' : ',byte(_field^[14]._pvalue^));
    if(_field^[15]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[15]._pname^),25,0),' : ',byte(_field^[15]._pvalue^));
    if(_field^[16]._pvalue<>nil)then
     writeln(out,' '+DopSpace(string(_field^[16]._pname^),25,0),' : ',
      '0x',HexStr(_field^[16]._pvalue,_field^[16]._size,'',1,1));
    if(_field^[28]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[28]._pname^),25,0),' : ',byte(_field^[28]._pvalue^));
    if(_field^[29]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[29]._pname^),25,0),' : ',byte(_field^[29]._pvalue^));
    if(_field^[30]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[30]._pname^),25,0),' : ',
      '0x',HexStr(_field^[30]._pvalue,_field^[30]._size,'',1,1));
    if(_field^[31]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[31]._pname^),25,0),' : ',
      '0x',HexStr(_field^[31]._pvalue,_field^[31]._size,'',1,1));
    if(_field^[32]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[32]._pname^),25,0),' : ',
      '0x',HexStr(_field^[32]._pvalue,_field^[32]._size,'',1,1));
    if(_field^[33]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[33]._pname^),25,0),' : ',
      '0x',HexStr(_field^[33]._pvalue,_field^[33]._size,'',1,1));
    if(_field^[34]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[34]._pname^),25,0),' : ',GUID2Str(_field^[34]._pvalue));
    if(_field^[39]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[39]._pname^),25,0),' : ',GUID2Str(_field^[39]._pvalue));
    if(_field^[46]._pvalue<>nil)
     then writeln(out,' '+DopSpace(string(_field^[46]._pname^),25,0),' : ',
      '0x',HexStr(_field^[46]._pvalue,_field^[46]._size,'',1,1));

    if(_field^[48]._pvalue<>nil) then begin
     ConvertToSystime(_field^[48]._pvalue,@sqltime);
     writeln(out,' '+DopSpace(string(_field^[48]._pname^),25,0),' : ',SystimeToStr(@sqltime,true));
    end;
    if(_field^[50]._pvalue<>nil) then begin
     ConvertToSystime(_field^[50]._pvalue,@sqltime);
     writeln(out,' '+DopSpace(string(_field^[50]._pname^),25,0),' : ',SystimeToStr(@sqltime,true));
    end;
    if(_field^[52]._pvalue<>nil)then
     writeln(out,' '+DopSpace(string(_field^[52]._pname^),25,0),' : ',
      '0x',HexStr(_field^[52]._pvalue,_field^[52]._size,'',1,1));
    if(_field^[47]._pvalue<>nil)then
     writeln(out,' '+DopSpace(string(_field^[47]._pname^),25,0),' : ',
      '0x',HexStr(_field^[47]._pvalue,_field^[47]._size,'',1,1));

   end {with} else writeln('Warning. Can''t parse row [boot]');
  end else writeln('Warning. Can''t get 1-st row [boot]');
  mdfTableClose(tab);
 end else writeln('Warning. Can''t initialise table [boot]');
end;

procedure printComment(var out:text;objId:dword;pageStream:PmdfPageStream;number:word);
var
 tabSyscomments:PmdfTable;
 f_id,f_colid,f_ctext,f_status,f_number,i,j,status:word;
 p:pointer;
 s,s1:string;
begin
  tabSyscomments:=mdfTableOpenEx(pageStream,id_Syscomments,0);
  if tabSyscomments<>nil then begin
   mdfTableInitFromTableEx(tabSyscomments);
   f_id:=0;f_colid:=0;f_ctext:=0;
   with tabSyscomments^ do for i:=1 to _field_count do begin
    if(_field^[i]._pname<>nil)then begin
     s:=upcase(string(_field^[i]._pname^));
     if s='ID'     then f_id:=i     else
     if s='COLID'  then f_colid:=i  else
     if s='CTEXT'  then f_ctext:=i  else
     if s='NUMBER' then f_number:=i else
     if s='STATUS' then f_status:=i;
    end;
   end;
   s1:='0x';
   if(f_id>0)and(f_colid>0)and(f_ctext>0)and(mdfTableFirstRow(tabSyscomments))then begin
    repeat
     if mdfTableRowParseEx(tabSyscomments) then begin
      with tabSyscomments^ do begin
       if(_field^[f_id]._pvalue<>nil)and
        (dword(_field^[f_id]._pvalue^)=objId)and
        ((number=0)or((_field^[f_number]._pvalue<>nil)
         and(word(_field^[f_number]._pvalue^)=number)))then begin
        p:=_field^[f_ctext]._pvalue;
        i:=_field^[f_ctext]._size;
        if(_field^[f_status]._pvalue<>nil)then
         status:=word(_field^[f_status]._pvalue^) else status:=0;
        if(p<>nil)and(i>0)then begin
         if(status and 1)<>0 then begin
          write(out,s1);
          s1:='';
          j:=127;
          while i>0 do begin
           if i<j then j:=i;
           s:=HexStr(p,j,'',1,0);
           write(out,s);
           dec(i,j);
          end;
         end else if(status and 2)=0 then begin
          j:=127;
          while i>0 do begin
           if i<(j shl 1) then j:=(i shr 1);
           byte(s[0]):=j;
           UnicodeToStr(p,@s[1],j);
           write(out,s);
           inc(p,j shl 1);
           dec(i,j shl 1);
          end;
         end else begin
          j:=127;
          while i>0 do begin
           if i<j then j:=i;
           byte(s[0]):=j;
           MemCopy(p,@s[1],j);
           write(out,s);
           inc(p,j);
           dec(i,j);
          end;
         end;
        end;
       end;
      end;
     end;
    until not mdfTableNextRow(tabSyscomments);
   end;
   mdfTableClose(tabSyscomments);
  end;
end;

function getTypeInfo(pageStream:PmdfPageStream;xtype:byte;xusertype:word;var ti:TmdfTypeInfo):boolean;
begin
 result:=false;
 if ti.tab=nil then begin
  ti.tab:=mdfTableOpenEx(pageStream,id_Systypes,0);
  if ti.tab<>nil then begin
   mdfTableInitFromTableEx2(ti.tab);
   if ti.tab^._field_count=0 then mdfSysTablesInitTable(ti.tab,id_Systypes);
  end;
 end;
 if ti.tab=nil then exit;
 if mdfTableFirstRow(ti.tab)then
  with ti do repeat
   //write('. ');
   if((tab^._ex)and(mdfTableRowParseEx(tab)))
    or(mdfTableRowParse(tab))then begin

     if(tab^._field^[2]._pvalue<>nil)and
       (byte(tab^._field^[2]._pvalue^)=xtype)and
       (tab^._field^[4]._pvalue<>nil)and
       (word(tab^._field^[4]._pvalue^)=xusertype)then begin

      {2} _xtype:=xtype;
      {4} _xusertype:=xusertype;

      {1}if(tab^._field^[1]._pvalue<>nil)and(tab^._field^[1]._size>0)then begin
       byte(_name[0]):=tab^._field^[1]._size shr 1;
       UnicodeToStr(tab^._field^[1]._pvalue,@_name[1],byte(_name[0]));
      end else _name:='';

      {3}if(tab^._field^[3]._pvalue<>nil)then
       _status:=byte(tab^._field^[3]._pvalue^) else _status:=0;

      {5}if(tab^._field^[5]._pvalue<>nil)then
       _length:=word(tab^._field^[5]._pvalue^) else _length:=0;

      {6}if(tab^._field^[6]._pvalue<>nil)then
       _xprec:=byte(tab^._field^[6]._pvalue^) else _xprec:=0;

      {7}if(tab^._field^[7]._pvalue<>nil)then
       _xscale:=byte(tab^._field^[7]._pvalue^) else _xscale:=0;

      {8}if(tab^._field^[8]._pvalue<>nil)then
       _tdefault:=dword(tab^._field^[8]._pvalue^) else _tdefault:=0;

      {9}if(tab^._field^[9]._pvalue<>nil)then
       _domain:=dword(tab^._field^[9]._pvalue^) else _domain:=0;

      {10}if(tab^._field^[10]._pvalue<>nil)then
       _uid:=word(tab^._field^[10]._pvalue^) else _uid:=0;

      {11}if(tab^._field^[11]._pvalue<>nil)then
       _reserved:=word(tab^._field^[11]._pvalue^) else _reserved:=0;

      {12}if(tab^._field^[12]._pvalue<>nil)then
       _collationid:=dword(tab^._field^[12]._pvalue^) else _collationid:=0;

      result:=true;
      //write('ok ');
      break;
     end;

   end;
  until not mdfTableNextRow(tab);
  //writeln('end');
end;


procedure printTableSchema(objId:dword;pageStream:PmdfPageStream);
var
    tabSyscolumns:PmdfTable;
    tabSystypes:PmdfTable;
    s,s1:string;
    out:text;
    w:word;
    p:pointer;

 function GetTypeName(xtype:word):string;
 begin
  result:='unknown';
  if mdfTableFirstRow(tabSystypes)then
   repeat
    if mdfTableRowParse(tabSystypes) then begin
     with tabSystypes^ do
      if(_field^[4]._pvalue<>nil)and
        (word(_field^[4]._pvalue^)=xtype)and
        (_field^[1]._pvalue<>nil)and(_field^[1]._size<>0)then begin
       byte(result[0]):=_field^[1]._size shr 1;
       UnicodeToStr(_field^[1]._pvalue,@result[1],byte(result[0]));
       break;
      end;
    end;
   until not mdfTableNextRow(tabSystypes);
 end;

begin

 assign(out,fullname);
 rewrite(out);
 tabSyscolumns:=mdfTableOpenEx(pageStream,id_Syscolumns,0);
 if tabSyscolumns<>nil then begin
  mdfSysTablesInitTable(tabSyscolumns,id_Syscolumns);
  tabSystypes:=mdfTableOpenEx(pageStream,id_Systypes,0);
  if tabSystypes<>nil then begin
   mdfSysTablesInitTable(tabSystypes,id_Systypes);
   if mdfTableFirstRow(tabSyscolumns)then begin
    writeln(out);
    write(out,' CREATE TABLE ['+objname+'] (');
    s:=' ';
    repeat
     if mdfTableRowParse(tabSyscolumns) then begin

      if(tabSyscolumns^._field^[2]._pvalue<>nil)and
       (dword(tabSyscolumns^._field^[2]._pvalue^)=objId)then begin

       writeln(out,s);

       s:='';s1:='';
       with tabSyscolumns^ do begin

        if(_field^[1]._pvalue<>nil)and
          (_field^[1]._size<>0)then begin
         byte(s[0]):=_field^[1]._size shr 1;
         UnicodeToStr(_field^[1]._pvalue,@s[1],byte(s[0]));
        end else s:='<NULL>';

        s:=#9'['+s+']';
        if(_field^[13]._pvalue<>nil)and((word(_field^[13]._pvalue^)and 4)<>0)
        and(_field^[9]._pvalue<>nil)and(word(_field^[9]._pvalue^)<>0)then begin
         write(out,s+s1+' AS ');
         s:='';s1:='';
         printComment(out,objId,pageStream,word(_field^[9]._pvalue^));
        end else begin
         if(_field^[5]._pvalue<>nil)then
          s1:=GetTypeName(word(_field^[5]._pvalue^))
         else if(_field^[3]._pvalue<>nil)then
          s1:=GetTypeName(word(_field^[3]._pvalue^))else s1:='<NULL>';

         s:=s+' ['+s1+']';
         if(_field^[6]._pvalue<>nil)then w:=word(_field^[6]._pvalue^) else w:=0;

         if(not(word(_field^[3]._pvalue^)in[type_int,type_bigint,type_datetime,
           type_smalldatetime,type_money,type_smallmoney,type_tinyint,type_decimal,type_numeric,
           type_smallint,type_uniqueidentifier,type_timestamp,type_real,
           type_float,type_bit,type_text,type_ntext,type_image]))then begin
           Str(w,s1);
           s1:=' ('+s1+')';
         end else s1:='';

         s:=s+s1;s1:='';

         if(word(_field^[3]._pvalue^)in[type_numeric,type_decimal])and
          (_field^[7]._pvalue<>nil)and(_field^[8]._pvalue<>nil)then begin
           Str(byte(_field^[7]._pvalue^),s1);
           s:=s+' ('+s1+', ';
           Str(byte(_field^[8]._pvalue^),s1);
           s:=s+s1+')';s1:='';
         end;

         p:=_field^[18]._pvalue;
         if(p<>nil)and(_field^[18]._size=(w*3)+1)and(w in[1,2,4,8])then begin
          if((PAByte(p)^[_field^[18]._size])=$82)
          or((PAByte(p)^[_field^[18]._size])=$03)then begin
           if((PAByte(p)^[_field^[18]._size])=$03)then s1:=' NOT FOR REPLICATION';
           write(out,s,' IDENTITY (');
           case w of
            1: write(out,PAByte(p)^[3],', ',PAByte(p)^[2]);
            2: write(out,smallint(PAWord(p)^[3]),', ',smallint(PAWord(p)^[2]));
            4: write(out,PALongint(p)^[3],', ',PALongint(p)^[2]);
            8: begin
                inc(p,16);
                write(out,Int64(p^),', ');
                dec(p,8);
                write(out,Int64(p^));
               end;
           end;
           s:=')';
          end;
         end;

         s:=s+s1;s1:=' NULL';
         if(_field^[4]._pvalue<>nil)and(byte(_field^[4]._pvalue^)and 1<>0)then s1:=' NOT'+s1;

         if(_field^[14]._pvalue<>nil)and(dword(_field^[14]._pvalue^)<>0)then begin
          write(out,s+s1+' DEFAULT ');
          s:='';s1:='';
          printComment(out,dword(_field^[14]._pvalue^),pageStream,0);
         end;

        end;
       end; // with
       s:=s+s1;
       write(out,s);
       s:=',';
      end;

     end;
    until not mdfTableNextRow(tabSyscolumns);
    s:=')';
    writeln(out,s);
   end;
   mdfTableClose(tabSystypes);
  end;
  mdfTableClose(tabSyscolumns);
 end;
 close(out);
end;

procedure printTable(objId:dword;pageStream:PmdfPageStream);
var
 tab:PmdfTable;
 p:pointer;
 L:dword;
 s:string;
 i:integer;
 out:text;
 date4:TDate4;
 date8:TDate8;
 sqltime:TSQLTime;
 qw:qword;

 ti:TmdfTypeInfo;
 blob:TmdfBlob;

 tmp_type:byte;
 tmp_size:dword;
 tmp_pvalue:pointer;
 tmp_xscale:dword;

begin
 //writeln('Warning. printTable');

 ti.tab:=nil;
 blob._pvalue:=nil;
 assign(out,fullname);
 rewrite(out);
 tab:=mdfTableOpenEx(pageStream,objId,1);
 if tab<>nil then begin
  if pageStream^._version>80 then
   writeln(' alloc. id : ',tab^._auid._auid,' (',tab^._auid._id,')');
  //readln;
  mdfTableInitFromTableEx2(tab);//readln;
  if tab^._field_count=0 then mdfSysTablesInitTable(tab,objId);
  writeln(' clustered : ',tab^._clustered);
  if tab^._iam<>nil then with tab^._iam^ do begin
   writeln('1st IAM pid: ',HexStr(_page._ph.m_pageId._fid,2),':',HexStr(_page._ph.m_pageId._id,4));
  end;
  //--------------
  //writeln(' field count: ',tab^._field_count);
  //writeln(' header: ');
  //p:=@tab^._page;
  //for i:=0 to 5 do begin
  // writeln('  ',HexStr(i shl 4,1),': ',HexStr(p,16,' ',1,0));
  // inc(p,16);
  //end;
  //--------------
  with tab^ do for i:=1 to _field_count do begin
   p:=_field^[i]._pname;
   L:=pbyte(p)^;
   inc(p);
   write(out,'"');
   repeat write(out,EscapeStr(p,L));
   until L=0;
   write(out,'"');
   //write(out,string(_field^[i]._pname^));
   if i=_field_count then writeln(out) else write(out,'|');
  end;
  qw:=0;
  if mdfTableFirstRow(tab)then begin
   repeat
    if((tab^._ex)and(mdfTableRowParseEx(tab)))
     or(mdfTableRowParse(tab))then begin
     inc(qw);write(' records   : ',qw,' / ',tab^._rowCnt,#13);
     //write(out,'[0x',HexStr(tab^._current_row,2),'] ');
     with tab^ do for i:=1 to _field_count do begin
      tmp_pvalue:=_field^[i]._pvalue;
      tmp_size:=_field^[i]._size;
      tmp_type:=_field^[i]._type;
      tmp_xscale:=_field^[i]._xscale;
     {------------------------------------------------------------}
      if(tmp_pvalue<>nil)and(tmp_size>0)then begin

       if(tmp_type in[type_image,type_ntext,type_text])
        and(_field^[i]._link)then begin
        if(tmp_size=16)then begin
         mdfGetBlob(pageStream,tmp_pvalue,blob);
         tmp_size:=blob._size;
         tmp_pvalue:=blob._pvalue;
        end else tmp_type:=type_binary;
       end;

       if tmp_type=type_sql_variant then begin
        case PByte(tmp_pvalue)^ of
         type_tinyint,
         type_smallint,
         type_int,
         type_uniqueidentifier,
         type_timestamp,
         type_bigint,
         type_real,
         type_float,
         type_numeric,
         type_decimal,
         type_bit,
         type_smalldatetime,
         type_datetime,
         type_smallmoney,
         type_money: begin
           tmp_type:=PByte(tmp_pvalue)^;
           inc(PByte(tmp_pvalue),2);
           tmp_size:=tmp_size-2;
           //tmp_xscale:=4;
          end;
         type_varbinary,
         type_binary:begin
           tmp_type:=PByte(tmp_pvalue)^;
           inc(PByte(tmp_pvalue),2);
           if tmp_size-4<PWord(tmp_pvalue)^
            then dec(tmp_size,4)
            else tmp_size:=PWord(tmp_pvalue)^;
           inc(PByte(tmp_pvalue),2);
          end;
         type_varchar,
         type_char,
         type_nchar,
         type_nvarchar:begin
           tmp_type:=PByte(tmp_pvalue)^;
           inc(PByte(tmp_pvalue),2);
           if tmp_size-8<PWord(tmp_pvalue)^
            then dec(tmp_size,8)
            else tmp_size:=PWord(tmp_pvalue)^;
           inc(PByte(tmp_pvalue),6);
         end else begin
          tmp_type:=type_binary;
         end;
        end; {case}
        if getTypeInfo(pageStream,tmp_type,tmp_type,ti)then begin
         tmp_xscale:=ti._xscale;

        end;
       end;
      end;
     {------------------------------------------------------------}
      if(tmp_pvalue<>nil)and(tmp_size>0)then begin
       case tmp_type of
       type_tinyint:          write(out,byte(tmp_pvalue^));
       type_smallint:         write(out,smallint(tmp_pvalue^));
       type_int:              write(out,longint(tmp_pvalue^));
       type_uniqueidentifier,
       type_timestamp:        write(out,Int64(tmp_pvalue^));
       type_bigint:           write(out,int64(tmp_pvalue^));
       type_real:             write(out,single(tmp_pvalue^));
       type_float:            write(out,double(tmp_pvalue^));

       type_money:    begin
                       L:=tmp_xscale;
                       if L=0 then write(out,int64(tmp_pvalue^))else
 //                       write(out,int64(_field^[i]._pvalue^)/(10**L):1:L);
                        write(out,int64(tmp_pvalue^)/(exp(ln(10)*L)):1:L);
                      end;
       type_smallmoney:begin
                       L:=tmp_xscale;
                       if L=0 then write(out,longint(tmp_pvalue^))else
 //                       write(out,longint(_field^[i]._pvalue^)/(10**L):1:L);
                        write(out,longint(tmp_pvalue^)/(exp(ln(10)*L)):1:L);
                      end;

       type_bit:      if _field^[i]._bitnum<8 then begin
                       if byte(tmp_pvalue^)and(1 shl _field^[i]._bitnum)=0
                       then write(out,'0')else write(out,'1');
                      end else write(out,'<',_field^[i]._bitnum,'>');

       type_numeric,
       type_decimal:  begin
                       L:=tmp_xscale;
                       if byte(tmp_pvalue^)=0 then write(out,'-');
                        if tmp_size=9 then begin
                         if L=0 then write(out,qword((tmp_pvalue+1)^))else
 //                         write(out,int64((_field^[i]._pvalue+1)^)/(10**L):1:L);
                          write(out,qword((tmp_pvalue+1)^)/(exp(ln(10)*L)):1:L);
                        end else if tmp_size=5 then begin
                         if L=0 then write(out,dword((tmp_pvalue+1)^))else
 //                         write(out,longint((_field^[i]._pvalue+1)^)/(10**L):1:L);
                          write(out,dword((tmp_pvalue+1)^)/(exp(ln(10)*L)):1:L);
                        end else write(out,'type: ',tmp_type,'(',tmp_size,') not supported');
                      end;

       type_text,
       type_varchar,
       type_char:     begin
                       L:=tmp_size;
                       p:=tmp_pvalue;
                       //write(out,'[objId:',HexStr(objId,4),'][size:',HexStr(L,4),']','[pid:',HexStr(_first_pid._id,4),']','[rowsize:',_rowLength,']');
                       write(out,'"');
                       repeat write(out,EscapeStr(p,L));
                       until L=0;
                       {byte(s[0]):=255;
                       while L>255 do begin
                        MemCopy(p,@s[1],255);
                        write(out,s);
                        inc(p,255);
                        dec(L,255)
                       end;
                       if L>0 then begin
                        byte(s[0]):=byte(L);
                        MemCopy(p,@s[1],L);
                        write(out,s);
                       end;}
                       write(out,'"');
                      end;

       type_xml,
       type_image,
       type_varbinary,
       type_binary:   begin
                       L:=tmp_size;
                       p:=tmp_pvalue;
                       write(out,'0x');
                       byte(s[0]):=127;
                       while L>127 do begin
                        write(out,HexStr(p,127,'',0,0));
                        inc(p,127);
                        dec(L,127)
                       end;
                       if L>0 then begin
                        write(out,HexStr(p,L,'',0,0));
                       end;
                      end;

       type_ntext,
       type_nchar,
       type_nvarchar: begin
                       L:=tmp_size shr 1;
                       p:=tmp_pvalue;
                       write(out,'"');
                       UnicodeToStr(p,p,L);
                       repeat write(out,EscapeStr(p,L));
                       until L=0;
                       {byte(s[0]):=127;
                       while L>254 do begin
                        UnicodeToStr(p,@s[1],127);
                        write(out,s);
                        inc(p,254);
                        dec(L,254)
                       end;
                       L:=L shr 1;
                       if L>0 then begin
                        byte(s[0]):=byte(L);
                        UnicodeToStr(p,@s[1],L);
                        write(out,s);
                       end;}
                       write(out,'"');
                      end;

       type_datetime: begin
                              ConvertToSystime(tmp_pvalue,@sqltime);
                              s:=SystimeToStr(@sqltime,true);
                              if pos(' 00:00:00.000',s)=byte(s[0])-12 then dec(byte(s[0]),13);
                              write(out,s);
                      end;
       type_smalldatetime: begin
                              ConvertFromD4(tmp_pvalue,@date8);
                              ConvertToSystime(@date8,@sqltime);
                              s:=SystimeToStr(@sqltime,false);
                              if pos(' 00:00',s)=byte(s[0])-5 then dec(byte(s[0]),6);
                              write(out,s);
                      end;
(*       type_image,
       type_ntext,
       type_text:     begin
                       L:=tmp_size;
                       p:=tmp_pvalue;
                       if _field^[i]._link then write(out,'LINK:');
                       write(out,'0x');
                       byte(s[0]):=127;
                       while L>127 do begin
                        write(out,HexStr(p,127,'',0,0));
                        inc(p,127);
                        dec(L,127)
                       end;
                       if L>0 then begin
                        write(out,HexStr(p,L,'',0,0));
                       end;
                      end;*)
       else write(out,'type: ',tmp_type,'(',tmp_size,') not supported') end;
      end;
      if i=_field_count then writeln(out) else write(out,'|');
     {------------------------------------------------------------}
     end;
    end {else writeln('Warning. Cant''t parse row ',
     HexStr(tab^._page._ph.m_pageId._fid,2),':',
     HexStr(tab^._page._ph.m_pageId._id,4),':',
     HexStr(tab^._current_row,2),' ',
     HexStr(tab^._prow,tab^._rowLength,'',0,0))};
   until not mdfTableNextRow(tab);
  end else writeln('Warning. 1-st row not found');
  mdfTableClose(tab);
 end else writeln('Warning. Can''t open table');
 close(out);
 writeln; // do not remove - some bug
 if ti.tab<>nil then mdfTableClose(ti.tab);
 if blob._pvalue<>nil then MemFree(blob._pvalue);
end;

procedure printSProc(objId:dword;pageStream:PmdfPageStream);
var
 out:text;
{ out:longint;
 tabSyscomments:PmdfTable;
 f_id,f_colid,f_ctext,f_status,i,j,status:word;
 p:pointer;
 s,s1:string;
// outt:text;}
begin
 assign(out,fullname);
 rewrite(out);
 printComment(out,objId,pageStream,0);
 close(out);
// assign(outt,'sp_test.txt');
// rewrite(outt);
{ out:=FileCreate(fullname);
 if out<>-1 then begin
  tabSyscomments:=mdfTableOpenEx(pageStream,id_Syscomments);
  if tabSyscomments<>nil then begin
   mdfTableInitFromTableEx(tabSyscomments);
   f_id:=0;f_colid:=0;f_ctext:=0;
   with tabSyscomments^ do for i:=1 to _field_count do begin
    if(_field^[i]._pname<>nil)then begin
     s:=upcase(string(_field^[i]._pname^));
     if s='ID'     then f_id:=i     else
     if s='COLID'  then f_colid:=i  else
     if s='CTEXT'  then f_ctext:=i  else
     if s='STATUS' then f_status:=i;
    end;
   end;
   //writeln('fstatus = ',f_status);
   s1:='0x';
//   writeln(outt,objId,' ',f_id,' ',f_colid,' ',f_ctext);
   if(f_id>0)and(f_colid>0)and(f_ctext>0)and(mdfTableFirstRow(tabSyscomments))then begin
    repeat
     if mdfTableRowParseEx(tabSyscomments) then begin
      with tabSyscomments^ do begin
       if(_field^[f_id]._pvalue<>nil)and
        (dword(_field^[f_id]._pvalue^)=objId)then begin
        p:=_field^[f_ctext]._pvalue;
        i:=_field^[f_ctext]._size;
        if(_field^[f_status]._pvalue<>nil)then
         status:=word(_field^[f_status]._pvalue^) else status:=0;

 //       write(outt,word(_field^[f_colid]._pvalue^),' ');
 //       if(p<>nil)and(i>0)then writeln(outt,FileWrite(out,p^,i));
        if(p<>nil)and(i>0)then begin
         //write('[',dword(_field^[f_id]._pvalue^),']');
         //write('[',HexStr(word(_field^[f_colid]._pvalue^),2),']');
         //write('[',HexStr(word(_field^[f_status]._pvalue^),2),']');
         //write('[',HexStr(status,2),']');
         if(status and 1)<>0 then begin
          FileWrite(out,s1[1],byte(s1[0])); //HexStr(p,i,'',1,0)
          s1:='';
          j:=127;
          while i>0 do begin
           if i<j then j:=i;
           s:=HexStr(p,j,'',1,0);
           FileWrite(out,s[1],j);
           dec(i,j);
          end;
         end else if(status and 2)=0 then begin
          j:=127;
          while i>0 do begin
           if i<(j shl 1) then j:=(i shr 1);
           byte(s[0]):=j;
           UnicodeToStr(p,@s[1],j);
           FileWrite(out,s[1],j);
           inc(p,j shl 1);
           dec(i,j shl 1);
          end;
         end else begin
          FileWrite(out,p^,i);
         end;
        end;
       end;
      end;
     end;
    until not mdfTableNextRow(tabSyscomments);
   end;
   mdfTableClose(tabSyscomments);
  end;
  FileClose(out);
 end;
// close(outt);}
end;

(*procedure listObjects(f:longint;start:Int64;size:Int64;mtfPath:string);
var
 tab:PmdfTable;
 pageStream:PmdfPageStream;
 s,s1:string;
 f1,f2,f3:byte;
 ex:boolean;
begin
 pageStream:=mdfPageOpen(f,start,size);
 if pageStream=nil then die('Error. Memory allocation error');
 writeln(sZeroTime+' ',mtfPath+'dbinfo.txt');
{ // -------------- read configuration from first page
 tab:=MemAlloc(SizeOf(TmdfTable));
 if tab<>nil then begin
  MemCopy(pageStream^._pbuff,@(tab^._page),CmdfPageSize);
  with tab^ do begin
   _stream:=pageStream;
   _id:=id_allocation;
   _current_row:=0;
   _first_pid:=_page._ph.m_pageId;
  end;
  mdfSysTablesInitTable(tab,id_allocation);
  if(mdfTableFirstRow(tab))and(mdfTableRowParse(tab))then begin
   if(tab^._field^[2]._pvalue<>nil)and(tab^._field^[2]._size=4)then
    writeln(HexStr(pbyte(tab^._field^[2]._pvalue)^,1));
  end;
  mdfTableClose(tab);
 end;
 // -------------- read configuration from first page}
 f1:=1;f2:=3;f3:=10;
 tab:=mdfTableOpenEx(pageStream,id_sysobjects);
 ex:=true;
 if tab=nil then begin
  ex:=false;
  //tab:=mdfTableOpen(pageStream,id_system_objects);
  //if tab=nil then begin
   tab:=mdfTableOpen(pageStream,id_sysschobjs);
   mdfSysTablesInitTable(tab,id_sysschobjs);
   if tab<>nil then begin
    //writeln('Warning. q1');
   end;
   f1:=2;f2:=6;
  //end else mdfSysTablesInitTable(tab,id_system_objects);
 end else mdfTableInitFromTableEx(tab);
 if tab<>nil then begin
  if mdfTableFirstRow(tab)then begin
   //writeln('Warning. q3');
   repeat
    //writeln('Warning. q4');
    if((Ex)and(mdfTableRowParseEx(tab)))
     or(mdfTableRowParse(tab))then begin
     //writeln('Warning. q2');
     {------------------------------------------------------------}
     with tab^ do begin
      //if(_field^[f2]._pvalue<>nil)then writeln('Warning. ',asStr(word(_field^[f2]._pvalue^),2));
      if(_field^[f2]._pvalue<>nil)and(not((word(_field^[f2]._pvalue^))in[obj_D]))then begin
       if(_field^[f3]._pvalue<>nil)and(_field^[f3]._size<>0)then begin
        ConvertToSystime(_field^[f3]._pvalue,@sqltime);
        s1:=SystimeToStr(@sqltime,true);
       end else s1:=sZeroTime;
       s1:=s1+' ';
       if(_field^[f1]._pvalue<>nil)and(_field^[f1]._size<>0)then begin
        byte(s[0]):=_field^[f1]._size shr 1;
        UnicodeToStr(_field^[f1]._pvalue,@s[1],byte(s[0]));
        StrToOem(@s[1],@s[1],byte(s[0]));
       end else s:='<NULL>';
       if(_field^[f2]._pvalue<>nil)then
        case word(_field^[f2]._pvalue^) of
        obj_C : write(s1,mtfPath+'check constraints\');
        obj_D : write(s1,mtfPath+'default constraints\');
        obj_F : write(s1,mtfPath+'foreign key constraints\');
        obj_L : write(s1,mtfPath+'logs\');
        obj_FN: write(s1,mtfPath+'scalar functions\');
        obj_IF: write(s1,mtfPath+'inlined table-functions\');
        obj_P : write(s1,mtfPath+'stored procedures\');
        obj_PK: write(s1,mtfPath+'primary key constraints\');
        obj_RF: write(s1,mtfPath+'replication filters\');
        obj_TF: write(s1,mtfPath+'table functions\');
        obj_TR: write(s1,mtfPath+'triggers\');
        obj_UQ: write(s1,mtfPath+'unique constraints\');
        obj_V : write(s1,mtfPath+'views\');
        obj_X : write(s1,mtfPath+'extended stored procedures\');
        obj_S : begin
                 writeln(s1,mtfPath+'system tables\schema\'+s+'.sql');
                 write(s1,mtfPath+'system tables\');
                end;
        obj_U : begin
                 writeln(s1,mtfPath+'user tables\schema\'+s+'.sql');
                 write(s1,mtfPath+'user tables\');
                end;
        end; {case}
       if(s[byte(s[0])] in [' ','.'])then s:='['+s+']';
       writeln(s);
      end;
     end;
     {------------------------------------------------------------}
    end;
   until not mdfTableNextRow(tab);
  end else if vrb then writeln('error read sysobjects');
  mdfTableClose(tab);
  writeln; {!! do not remove this !! some bug !!}
 end else die('error open sysobjects');
 mdfPageClose(pageStream);
end;*)

begin
 writeln('MDFReader 1.5 for MSSQL 7/8/9 data-files by General Paul Lee (c) 2005-2006.');
 ParseCmdLine;
 f:=FileOpen(fname,fmOpenRead);
 if f=-1 then die('file open error');
 if cmd='l' then begin
  FileRead(F,L,4);
  if L=Cmtf_TAPE then begin
   pMtf:=mtfOpen(F);
   if pMtf=nil then die('Error. Can''t open device.');
   writeln(sZeroTime,' dirinfo.txt');
   p:=pMtf^._dataset;
   i:=0;
   while p<>nil do begin
    inc(i);str(i,s);
    s:='DS'+s+' (';
    if(PmtfDataSet(p)^._name<>nil)then begin
     s:=s+PmtfDataSet(p)^._name^;
     if byte(s[0])>50 then begin
      byte(s[0]):=30;
      s:=s+'...';
     end;
    end else s:=s+'noname';
    for j:=1 to byte(s[0]) do if pos(s[j],'\/"''*?:;<>')>0 then s[j]:='_';
    s:=s+')\';
    writeln(PmtfDataSet(p)^._created+' ',s);
    writeln(sZeroTime+' ',s,'dirinfo.txt');
    listObjectsEx(f,PmtfDataSet(p)^._startFirstData,PmtfDataSet(p)^._sizeFirstData,s);
    p:=PmtfDataSet(p)^.Next;
   end;
   mtfClose(pMtf);
  end else begin
   listObjectsEx(f,0,FileSize(f),'');
   writeln; //do not remove - some bug
  end;
 end else if cmd in ['e','x'] then begin
  {---------------------------------------------------------------}

  FileRead(F,L,4);
  if L=Cmtf_TAPE then begin
   pMtf:=mtfOpen(F);
   if pMtf=nil then die('Can''t open device.');
   if objname='dirinfo.txt' then begin
    assign(out,objname);
    rewrite(out);
    with pMtf^ do begin
     writeln(out);
     writeln(out,' Tape created     : ',_created);
     writeln(out,' Operation system : ',mtfGetOsId(_hdr._common._osId));
     if _software<>nil then
      writeln(out,' Software name    : ',_software^);
     writeln(out,' Data set number  : ',_datasetcnt);
     if _name<>nil then
      writeln(out,' Tape name        : ',_name^);
     if _desc<>nil then
      writeln(out,' Description      : ',_desc^);
    end;
    close(out);
    mtfClose(pMtf);
    FileClose(f);
    exit;
   end;
   j:=0;
   if(copy(objname,1,2)='DS')then val(copy(objname,3,pos(' ',objname)-3),j,i)
   else die('Wrong parameter');
   if(i<>0)or(j<0)then die('Wrong parameter');
   p:=pMtf^._dataset;
   i:=0;
   while p<>nil do begin
    inc(i);if i=j then break;
    p:=PmtfDataSet(p)^.Next;
   end;
   if p<>nil then begin
    i:=pos('dirinfo.txt',objname);
    j:=pos('\',objname);
    if(i=byte(objname[0])-10)and(i=j+1)then begin
     if cmd='x' then begin
      DirCreate(objname);
      assign(out,objname);
     end else assign(out,'dirinfo.txt');
     rewrite(out);
     with PmtfDataSet(p)^ do begin
      writeln(out);
      if _name<>nil then
       writeln(out,' Dataset name     : ',_name^);
      writeln(out,' Created          : ',_created);
      if _desc<>nil then
       writeln(out,' Description      : ',_desc^);
      writeln(out,' Database name    : ',_config[0]^._dbName^);
      writeln(out,' Server name      : ',_config[0]^._srvName^);
      Str(_config[0]^._srvVer shr $18,s1);s:=s1+'.';
      if(_config[0]^._srvVer shr $10 and $0FF)<10 then s+='0';
      Str(_config[0]^._srvVer shr $10 and $0FF,s1);s+=s1+'.';
      Str(_config[0]^._srvVer and $0FFFF,s1);s+=s1;
      writeln(out,' Server version   : ',s);
      Str(_config[0]^._compatLevel,s);
      writeln(out,' Compatibility    : ',s);
      if _user<>nil then
       writeln(out,' User name        : ',_user^);
      writeln(out,' Backup type      : ',HexStr(_config[0]^._backupType,1)+'h ',mtfGetBackupTypeStr(_config[0]^._backupType));
      Str(_config[0]^._sortOrder,s);
      write(out,' Sort order       : ',s+' ',mtfGetSortOrderName(_config[0]^._sortOrder));
      writeln(out,' "'+mtfgetSortOrderDescr(_config[0]^._sortOrder)+'"');
      Str(_config[0]^._uniLocale,s);
      writeln(out,' Unicode locale   : ',s+' "',mtfGetUnicodeLocaleStr(_config[0]^._uniLocale)+'"');
      L:=_config[0]^._uniCmpFlags;
      Str(L,s);
      write(out,' Compare flags    : ',LTrim(HexStr(_config[0]^._uniCmpFlags,4),'0',1)+'h ('+s+')');
      if L and $30003 <> 0 then begin
       s:='';
       if L and 1 <> 0 then s:='Case-';
       if L and 2 <> 0 then begin
        if L and 1 <> 0  then s+=', ';
        s+='Accent-';
       end;
       if L and $10000 <> 0 then begin
        if L and 3 <> 0  then s+=', ';
        s+='Width-';
       end;
       if L and $20000 <> 0 then begin
        if L and $10003 <> 0  then s+=', ';
        s+='Kana-';
       end;
       s+=' insensitive';
       write(out,' "'+s+'"');
      end;
      writeln(out);
     end;
     close(out);
     mtfClose(pMtf);
     FileClose(f);
     exit;
    end;
    start:=PmtfDataSet(p)^._startFirstData;
    size:=PmtfDataSet(p)^._sizeFirstData;
   end else die('Wrong parameter');
   mtfClose(pMtf);
  end else begin
   start:=0;
   size:=FileSize(f);
  end;
  {---------------------------------------------------------------}
  pageStream:=mdfBaseInit(f,start,size);
  //pageStream:=mdfPageOpen(f,start,size);
  if pageStream=nil then die('Error. Memory allocation error');

  i:=pos('dbinfo.txt',objname);
  j:=pos('\',objname);
  if(i=byte(objname[0])-9)and(i=j+1)then begin
   if cmd='x' then begin
    DirCreate(objname);
    assign(out,objname);
   end else assign(out,'dbinfo.txt');
   rewrite(out);
   printDBInfo(out,pageStream);
   mdfBaseClose(pageStream);
   close(out);
   exit;
  end;

  objId:=0;
  oper:=0;
  i:=byte(objname[0]);
  while i>0 do if objname[i]='\' then break else dec(i);
  if i<2 then die('Error. Wrong parameter: '+objname);
  fullname:=objname;
  objname:=copy(objname,i+1,byte(objname[0])-i);
  L:=pos('tables\',fullname);
  if(L>0)and(L=byte(fullname[0])-6-byte(objname[0]))then oper:=1
  else begin
   L:=pos('schema\',fullname);
   if(L>0)and(L=byte(fullname[0])-6-byte(objname[0]))then begin
    oper:=2;
    dec(byte(objname[0]),4);
   end else oper:=3;
  end;
  s:=fullname;
  StrToOem(@s[1],@s[1],byte(s[0]));
  writeln(' extracting: ',s);
  if cmd='e' then fullname:=copy(fullname,i+1,byte(fullname[0])-i);
  {---------------------------------------------------------------}
  if(oper>0)and(oper<=3)then begin
   if(objname[1]='[')and(objname[byte(objname[0])]=']')then objname:=copy(objname,2,byte(objname[0])-2);
   objId:=getObjIdEx(objname,pageStream);
   if objId<>0 then begin
    writeln(' object id : ',objId);
    DirCreate(fullname);
    case oper of
     1: printTable(objId,pageStream);
     2: printTableSchema(objId,pageStream);
     3: printSProc(objId,pageStream);
    end;
   end;
  end;
  //mdfPageClose(pageStream);
  mdfBaseClose(pageStream);
 end;
 FileClose(f);
end.
