unit mtfDrv;

interface

uses plType;

{$I mtfDrv.inc}

type

 PmtfConfigInfo = ^TmtfConfigInfo;
 TmtfConfigInfo = packed record
  _dbCount:dword;                // 0C: "m_database_file_count"
  _logCount:dword;               // 10: "m_log_file_count"
  _nextId:dword;                 // 14: "m_next_id"
  _srvVer:dword;                 // 18: "m_server_version"
  _proc:dword;                   // 1C: "m_processor"
  _creationDate:string[20];      // 48: "m_creation_date"
  _backupStart:string[20];       // 4D: "m_backup_start"
  _backupFinish:string[20];      // 52: "m_backup_finish"
  _backupType:byte;              // 57: "m_backup_type"
  _sortOrder:byte;               // 58: "m_sort_order
  _sortOrderStatus:byte;         // 59: "m_sort_order_status"
  _codePage:byte;                // 5A: "m_code_page"
  _compatLevel:byte;             // 5B: "m_compatibility_level"
  _dbId:word;                    // 5C: "m_database_id"
  _dbVer:word;                   // 5E: "m_database_version"
  _backupSize:Int64;             // 60: "m_backup_size"
  _dbName:pstr;                  // 68: "m_database_name
  _srvName:pstr;                 // 6C: "m_server_name
  _minRestartPage:dword;         // 70: "m_minimum_restart_page
  _uniLocale:dword;              // 74: "m_unicode_locale"
  _uniCmpFlags:dword;            // 78: "m_unicode_compare_flags"
  _fileGeneration:dword;         // 8C: "m_file_generation"
 end;
 PAConfigInfo  = ^AConfigInfo;
 AConfigInfo   = array[0..255]of PmtfConfigInfo;

 PmtfFileGroup = ^TmtfFileGroup;
 TmtfFileGroup = packed record
  _id:word;
  _name:pstr;
 end;
 PAFileGroup  = ^AFileGroup;
 AFileGroup   = array[0..255]of PmtfFileGroup;

 PmtfFileInfo = ^TmtfFileInfo;
 TmtfFileInfo = packed record
  _grpId:word;
  _fnum:dword;
  _ftype:dword;
  _fsize:Int64;
  _lname:pstr;
  _pname:pstr;
 end;
 PAFileInfo  = ^AFileInfo;
 AFileInfo   = array[0..255]of PmtfFileInfo;

 PmtfDataSet = ^TmtfDataSet;
 TmtfDataSet = packed record
  Prev,Next:PmtfDataSet;
  _number:word; // data set number
  _start:Int64; // physical block address
  _name:pstr;
  _desc:pstr;
  _passwd:pstr;
  _user:pstr;
  _created:string[20];
  _grpCnt:byte;
  _fileCnt:byte;
  _cnfCnt:byte;
  _groups:AFileGroup;
  _files:AFileInfo;
  _config:AConfigInfo;
  _startFirstData:Int64;
  _sizeFirstData:Int64;
 end;

 PmtfDevice = ^TmtfDevice;
 TmtfDevice = packed record
  _file:longint;
  _hdr:TmtfTapeBlk;
  _name:pstr;
  _desc:pstr;
  _passwd:pstr;
  _software:pstr;
  _dataSetCnt:word;
  _dataSet:PmtfDataSet;
  _created:string[20];
//  _buff:array[0..$400-1]of byte;
//--
 end;

function  mtfOpen(f:longint):PmtfDevice;
procedure mtfClose(var p:PmtfDevice);
function  mtfGetOsId(osid:byte):string;
function  mtfGetBackupTypeStr(b:byte):string;

implementation

uses plOem,plMem,plFile64,plUni,plStr{,SysUtils};

{--------------------------------------------------------------}
function  getDate(d:TmtfDateTime):string;
var s:string;
begin
 str((d[0] shl 6) or (d[1] shr 2),s); result:=LTrim('0000'+s,'0',4);
 str(((d[1] and 3) shl 2) or ((d[2] and $0C0) shr 6),s);result:=result+'.'+LTrim('00'+s,'0',2);
 str((d[2] and $3E) shr 1,s);result:=result+'.'+LTrim('00'+s,'0',2);
 str(((d[2] and 1) shl 4) or ((d[3] and $0F0) shr 4),s);result:=result+' '+LTrim('00'+s,'0',2);
 str(((d[3] and $0F) shl 2) or ((d[4] and $0C0) shr 6),s);result:=result+':'+LTrim('00'+s,'0',2);
 str(d[4] and $3F,s);result:=result+':'+LTrim('00'+s,'0',2);
end;
{--------------------------------------------------------------}
function getStr(f:longint;off,size:word;start:Int64):pstr;
var q:pstr;
begin
 if(off<>0)and(size<>0)then begin
  result:=MemAlloc((size shr 1)+1);
  byte(result^[0]):=size shr 1;
  q:=MemAlloc(size);
  if(q<>nil)and(FileSeek(f,start+off,fsFromBeginning)<>-1)and(FileRead(f,q^,size)<>-1)then begin
   UnicodeToStr(q,@result^[1],byte(result^[0]));
   StrToOem(@result^[1],@result^[1],byte(result^[0]));
  end;
  MemFree(q);
 end else result:=nil;
end;
{--------------------------------------------------------------}
function mtfOpen(f:longint):PmtfDevice;
var p:PmtfDevice;
    q1:PmtfDataSet;
    q2:pointer;
    L,L1,fs:Int64;
    sset:TmtfSsetBlk;
    sh:TmtfSqlHdr;
    fg:TmtfSfgiBlk;
    fi:TmtfSfinBlk;
    ci:TmtfScinBlk;
    mq:TmtfStreamHdr;
    w:word;
    msls:boolean;
begin
 result:=nil;
 q1:=nil;
 if f=-1 then exit;
 fs:=FileSize(f);
 p:=MemAlloc(SizeOf(TmtfDevice));
 if p=nil then exit;
 if(FileSeek(f,0,fsFromBeginning)<>-1)and
   (FileRead(f,p^._hdr,SizeOf(TmtfTapeBlk))<>-1)and
   (p^._hdr._common._type=Cmtf_TAPE)then begin
   {with p^ do begin
    _file:=f;
    _name:=getStr(f,_hdr._name._off,_hdr._name._size,0);
    _desc:=getStr(f,_hdr._desc._off,_hdr._desc._size,0);
    _passwd:=getStr(f,_hdr._passwd._off,_hdr._passwd._size,0);
    _software:=getStr(f,_hdr._software._off,_hdr._software._size,0);
    _created:=getDate(_hdr._date);
    L:=_hdr._flbSize+_hdr._sfmSize*$200;
   end;}
   p^._file:=f;
   p^._name:=getStr(f,p^._hdr._name._off,p^._hdr._name._size,0);
   p^._desc:=getStr(f,p^._hdr._desc._off,p^._hdr._desc._size,0);
   p^._passwd:=getStr(f,p^._hdr._passwd._off,p^._hdr._passwd._size,0);
   p^._software:=getStr(f,p^._hdr._software._off,p^._hdr._software._size,0);
   p^._created:=getDate(p^._hdr._date);
   L:=p^._hdr._flbSize+p^._hdr._sfmSize*$200;
   while(L<fs)and(FileSeek(f,L,fsFromBeginning)<>-1)and
    (FileRead(f,sset,SizeOf(TmtfSsetBlk))<>-1)and
    (sset._common._type=Cmtf_SSET)do begin
    with sset do begin
     q2:=q1;
     q1:=MemAlloc(SizeOf(TmtfDataSet));
     if q1<>nil then begin
      q1^._name:=getStr(f,_name._off,_name._size,L);
      q1^._desc:=getStr(f,_desc._off,_desc._size,L);
      q1^._passwd:=getStr(f,_passwd._off,_passwd._size,L);
      q1^._user:=getStr(f,_user._off,_user._size,L);
      q1^._created:=getDate(_date);
      q1^._number:=_num;
      q1^._start:=_pba;
      if q2<>nil then begin
       q1^.Prev:=q2;
       PmtfDataSet(q2)^.Next:=q1;
      end;
      if p^._dataSet=nil then p^._dataSet:=q1;
      inc(p^._dataSetCnt);
     end;
    end;
    inc(L,sset._common._off);
    msls:=false;
    {-- full SSET}
    if q1<>nil then while(L<fs)and(FileSeek(f,L,fsFromBeginning)<>-1)and
     (FileRead(f,sh,SizeOf(TmtfSqlHdr))<>-1)do begin
     case sh._type of
      Cmtf_SSET:break;
      Cmtf_SPAD,Cmtf_APAD,Cmtf_MQTL,Cmtf_TSMP:begin
                 FileRead(f,L1,8);
                 inc(L,L1+$16);
                end;
      {Cmtf_TSMP:begin
                 FileSeek(f,L+$1E,fsFromBeginning);
                 FileRead(f,w,2);
                 inc(L,w+$20);
                end;}
      Cmtf_MSCI,Cmtf_VOLB,Cmtf_MSDA,Cmtf_MSTL,Cmtf_MSLS,
      Cmtf_SFMB,Cmtf_ESET,Cmtf_OTCP:begin
                 FileRead(f,w,2);
                 inc(L,w);
                 if not msls then msls:=sh._type=Cmtf_MSLS;
                end;
      Cmtf_MQCI:inc(L,$16);
      Cmtf_MQDA:begin
                 FileSeek(f,L,fsFromBeginning);
                 FileRead(f,mq,SizeOf(TmtfStreamHdr));
                 if q1^._startFirstData=0 then begin
                  q1^._startFirstData:=Int64(L)+Int64(SizeOf(TmtfStreamHdr))+Int64(2);
                  if(mq._length>=2)then
                   q1^._sizeFirstData:=Int64(mq._length)-Int64(2) else break;
                 end;
                 inc(L,mq._length+SizeOf(TmtfStreamHdr));
                end;
      Cmtf_SCIN:begin
                 FileSeek(f,L,fsFromBeginning);
                 FileRead(f,ci,SizeOf(TmtfScinBlk));
                 if not msls then begin
                  q2:=MemAlloc(Sizeof(TmtfConfigInfo));
                  if q2<>nil then begin
                   PmtfConfigInfo(q2)^._dbCount:=ci._dbCount;
                   PmtfConfigInfo(q2)^._logCount:=ci._logCount;
                   PmtfConfigInfo(q2)^._nextId:=ci._nextId;
                   PmtfConfigInfo(q2)^._srvVer:=ci._srvVer;
                   PmtfConfigInfo(q2)^._proc:=ci._proc;
                   PmtfConfigInfo(q2)^._creationDate:=getDate(ci._creationDate);
                   PmtfConfigInfo(q2)^._backupStart:=getDate(ci._backupStart);
                   PmtfConfigInfo(q2)^._backupFinish:=getDate(ci._backupFinish);
                   PmtfConfigInfo(q2)^._backupType:=ci._backupType;
                   PmtfConfigInfo(q2)^._sortOrder:=ci._sortOrder;
                   PmtfConfigInfo(q2)^._sortOrderStatus:=ci._sortOrderStatus;
                   PmtfConfigInfo(q2)^._codePage:=ci._codePage;
                   PmtfConfigInfo(q2)^._compatLevel:=ci._compatLevel;
                   PmtfConfigInfo(q2)^._dbId:=ci._dbId;
                   PmtfConfigInfo(q2)^._dbVer:=ci._dbVer;
                   PmtfConfigInfo(q2)^._backupSize:=ci._backupSize;
                   PmtfConfigInfo(q2)^._dbName:=getStr(f,ci._dbName._off,ci._dbName._size,L);
                   PmtfConfigInfo(q2)^._srvName:=getStr(f,ci._srvName._off,ci._srvName._size,L);
                   PmtfConfigInfo(q2)^._minRestartPage:=ci._minRestartPage;
                   PmtfConfigInfo(q2)^._uniLocale:=ci._uniLocale;
                   PmtfConfigInfo(q2)^._uniCmpFlags:=ci._uniCmpFlags;
                   PmtfConfigInfo(q2)^._fileGeneration:=ci._fileGeneration;
                   q1^._config[q1^._cnfCnt]:=q2;
                   inc(q1^._cnfCnt);
                  end;
                 end;
                 inc(L,ci._sh._size);
                end;
      Cmtf_SFGI:begin
                 FileSeek(f,L,fsFromBeginning);
                 FileRead(f,fg,SizeOf(TmtfSfgiBlk));
                 if not msls then begin
                  q2:=MemAlloc(Sizeof(TmtfFileGroup));
                  if q2<>nil then begin
                   PmtfFileGroup(q2)^._id:=fg._id;
                   PmtfFileGroup(q2)^._name:=getStr(f,fg._name._off,fg._name._size,L);
                   q1^._groups[q1^._grpCnt]:=q2;
                   inc(q1^._grpCnt);
                  end;
                 end;
                 inc(L,fg._sh._size);
                end;
      Cmtf_SFIN:begin
                 FileSeek(f,L,fsFromBeginning);
                 FileRead(f,fi,SizeOf(TmtfSfinBlk));
                 if not msls then begin
                  q2:=MemAlloc(Sizeof(TmtfFileInfo));
                  if q2<>nil then begin
                   PmtfFileInfo(q2)^._grpId:=fi._grpId;
                   PmtfFileInfo(q2)^._fnum:=fi._fnum;
                   PmtfFileInfo(q2)^._ftype:=fi._ftype;
                   PmtfFileInfo(q2)^._fsize:=fi._fsize;
                   PmtfFileInfo(q2)^._lname:=getStr(f,fi._lname._off,fi._lname._size,L);
                   PmtfFileInfo(q2)^._pname:=getStr(f,fi._pname._off,fi._pname._size,L);
                   q1^._files[q1^._fileCnt]:=q2;
                   inc(q1^._fileCnt);
                  end;
                 end;
                 inc(L,fi._sh._size);
                end;
     else if(sh._type and $0FF = 0)and(L and $0FF <> 0)then inc(L) else break;
     end; {case}
    end else break;
    {-- full SSET}
   end;
  end else mtfClose(p);
 result:=p;
end;
{--------------------------------------------------------------}
procedure mtfClose(var p:PmtfDevice);
var q:PmtfDataSet;
begin
 if p<>nil then with p^ do begin
  MemFree(_name);
  MemFree(_desc);
  MemFree(_passwd);
  MemFree(_software);
  q:=_dataSet;
  if q<>nil then begin
   while q^.Next<>nil do q:=q^.Next;
   while q^.Prev<>nil do begin
    q:=q^.Prev; MemFree(q^.Next);
   end;
   MemFree(q);
  end;
  MemFree(p);
 end;
end;
{--------------------------------------------------------------}
function mtfGetOsId(osid:byte):string;
begin
 case osId of
  Cmtf_OS_NETWARE     :result:='NetWare';
  Cmtf_OS_NETWARE_SMS :result:='NetWare SMS';
  Cmtf_OS_WINDOWS_NT  :result:='Windows NT';
  Cmtf_OS_DOS         :result:='DOS';
  Cmtf_OS_OS2         :result:='OS/2';
  Cmtf_OS_WINDOWS_95  :result:='Windows 95';
  Cmtf_OS_MACINTOSH   :result:='Macintosh';
  Cmtf_OS_UNIX        :result:='Unix';
 else result:='unknown '+HexStr(osId,1)+'h';
 end; {case}
end;
{--------------------------------------------------------------}
function  mtfGetBackupTypeStr(b:byte):string;
begin
 case b of
  $44: result:='full backup';
  $46: result:='backup type '+HexStr(b,1)+'h';
  $49: result:='differential backup';
  $4C: result:='backup type '+HexStr(b,1)+'h';
 else  result:='unknown backup type '+HexStr(b,1)+'h';
 end; {case}
end;
{--------------------------------------------------------------}

end.
