unit mtfLoc;
interface
function mtfGetSortOrderName(order:dword):string;
function mtfGetSortOrderDescr(order:dword):string;
function mtfGetUnicodeLocaleStr(locale:dword):string;
implementation
function mtfGetSortOrderStr(order:dword;b:boolean):string;
{Sort Order IDs
These tables show the sort order ID for each Microsoft SQL Server sort order.
Each sort order is applicable to one character set only.
Each table lists the available sort orders for the listed character set.
1988-98 Microsoft Corporation.}
begin
 case order of
 {1252 ISO character set}
   50: if b then result:='bin_iso_1'
       else result:='Binary order';
   51: if b then result:='dictionary_iso'
       else result:='Dictionary order, case-sensitive';
   52: if b then result:='nocase_iso'
       else result:='Dictionary order, case-insensitive';
   53: if b then result:='nocasepref_iso'
       else result:='Dictionary order, case-insensitive, uppercase preference';
   54: if b then result:='noaccents_iso'
       else result:='Dictionary order, case-insensitive, accent-insensitive';
   71: if b then result:='dictionary_1252'
       else result:='Latin-1 case-sensitive';
   72: if b then result:='nocase_1252'
       else result:='Latin-1 case-insensitive';
   73: if b then result:='Danish/Norwegian case-sensitive'
       else result:='danish_norwegian_1252';                // 1.5
   74: if b then result:='Finnish/Swedish case-sensitive'
       else result:='finnish_swedish_1252';                 // 1.5
   75: if b then result:='Icelandic case-sensitive'
       else result:='icelandic_1252';                       // 1.5
  183: if b then result:='danno_nocasepref'
       else result:='Danish/Norwegian dictionary order, case-insensitive, uppercase preference';
  184: if b then result:='svfi1_nocasepref'
       else result:='Swedish/Finnish (Standard) dictionary order, case-insensitive, uppercase preference';
  185: if b then result:='svfi2_nocasepref'
       else result:='Swedish/Finnish (Phone) dictionary order, case-insensitive, uppercase preference';
  186: if b then result:='islan_nocasepref'
       else result:='Icelandic dictionary order, case-insensitive, uppercase preference';
 {850 Multilingual}
   40: if b then result:='bin_cp850'
       else result:='Binary order';
   41: if b then result:='dictionary_850'
       else result:='Dictionary order, case-sensitive';
   42: if b then result:='nocase_850'
       else result:='Dictionary order, case-insensitive';
   43: if b then result:='nocasepref_850'
       else result:='Dictionary order, case-insensitive, uppercase preference';
   44: if b then result:='noaccents_850'
       else result:='Dictionary order, case-insensitive, accent-insensitive';
   49: if b then result:='caseless_34'
       else result:='Strict compatibility with version 1.x case-insensitive databases';
   55: if b then result:='alt_dictionary'
       else result:='Alternate dictionary order, case-sensitive';
   56: if b then result:='alt_nocasepref'
       else result:='Alternate dictionary order, case-insensitive, uppercase preference';
   57: if b then result:='alt_noaccents'
       else result:='Alternate dictionary order, case-insensitive, accent-insensitive';
   58: if b then result:='scand_nocasepref'
       else result:='Scandinavian dictionary order, case-insensitive, uppercase preference';
   59: if b then result:='scand_dictionary'
       else result:='Scandinavian dictionary order, case-sensitive';
   60: if b then result:='scand_nocase'
       else result:='Scandinavian dictionary order, case-insensitive';
   61: if b then result:='alt_nocase'
       else result:='Alternate dictionary order, case-insensitive';
 {437 U.S. English}
   30: if b then result:='bin_cp437'
       else result:='Binary order';
   31: if b then result:='dictionary_437'
       else result:='Dictionary order, case-sensitive';
   32: if b then result:='nocase_437'
       else result:='Dictionary order, case-insensitive';
   33: if b then result:='nocasepref_437'
       else result:='Dictionary order, case-insensitive, uppercase preference';
   34: if b then result:='noaccents_437'
       else result:='Dictionary order, case-insensitive, accent-insensitive';
 {874 Thai}
  204: if b then result:='bin_cp874'
       else result:='Binary order';
  205: if b then result:='nls_cp874'
       else result:='Dictionary order, case-insensitive';
  206: if b then result:='nls_cp874_cs'
       else result:='Dictionary order, case-sensitive';
 {932 Japanese}
  192: if b then result:='bin_cp932'
       else result:='Binary order';
  193: if b then result:='nls_cp932'
       else result:='Dictionary order, case-insensitive';
  200: if b then result:='nls_cp932_cs'
       else result:='Dictionary order, case-sensitive';
 {936 Chinese (simplified)}
  198: if b then result:='bin_cp936'
       else result:='Binary order';
  199: if b then result:='nls_cp936'
       else result:='Dictionary order, case-insensitive';
  203: if b then result:='nls_cp936_cs'
       else result:='Dictionary order, case-sensitive';
 {949 Korean}
  194: if b then result:='bin_cp949'
       else result:='Binary order';
  195: if b then result:='nls_cp949'
       else result:='Dictionary order, case-insensitive';
  201: if b then result:='nls_cp949_cs'
       else result:='Dictionary order, case-sensitive';
 {950 Chinese (traditional)}
  196: if b then result:='bin_cp950'
       else result:='Binary order';
  197: if b then result:='nls_cp950'
       else result:='Dictionary order, case-insensitive';
  202: if b then result:='nls_cp950_cs'
       else result:='Dictionary order, case-sensitive';
 {1250 Central European}
   80: if b then result:='bin_cp1250'
       else result:='Binary order';
   81: if b then result:='dictionary_1250'
       else result:='Dictionary order, case-sensitive';
   82: if b then result:='nocase_1250'
       else result:='Dictionary order, case-insensitive';
   83: if b then result:='csydic'
       else result:='Czech dictionary order, case-sensitive';
   84: if b then result:='csync'
       else result:='Czech dictionary order, case-insensitive';
   85: if b then result:='hundic'
       else result:='Hungarian dictionary order, case-sensitive';
   86: if b then result:='hunnc'
       else result:='Hungarian dictionary order, case-insensitive';
   87: if b then result:='plkdic'
       else result:='Polish dictionary order, case-sensitive';
   88: if b then result:='plknc'
       else result:='Polish dictionary order, case-insensitive';
   89: if b then result:='romdic'
       else result:='Romanian dictionary order, case-sensitive';
   90: if b then result:='romnc'
       else result:='Romanian dictionary order, case-insensitive';
   91: if b then result:='shldic'
       else result:='Croatian dictionary order, case-sensitive';
   92: if b then result:='shlnc'
       else result:='Croatian dictionary order, case-insensitive';
   93: if b then result:='skydic'
       else result:='Slovak dictionary order, case-sensitive';
   94: if b then result:='skync'
       else result:='Slovak dictionary order, case-insensitive';
   95: if b then result:='slvdic'
       else result:='Slovenian dictionary order, case-sensitive';
   96: if b then result:='slvnc'
       else result:='Slovenian dictionary order, case-insensitive';
   97: if b then result:='plks'
       else result:='Polish case-sensitive';   // 1.5
   98: if b then result:='plki'
       else result:='Polish case-insensitive'; // 1.5
 {1251 Cyrillic}
  104: if b then result:='bin_cp1251'
       else result:='Binary order';
  105: if b then result:='dictionary_1251'
       else result:='Dictionary order, case-sensitive';
  106: if b then result:='nocase_1251'
       else result:='Dictionary order, case-insensitive';
  107: if b then result:='ukrdic'
       else result:='Ukrainian dictionary order, case-sensitive';
  108: if b then result:='ukrnc'
       else result:='Ukrainian dictionary order, case-insensitive';
 {1253 Greek}
  112: if b then result:='bin_cp1253'
       else result:='Binary order';
  113: if b then result:='dictionary_1253'
       else result:='Dictionary order, case-sensitive';
  114: if b then result:='nocase_1253'
       else result:='Dictionary order, case-insensitive';
  120: if b then result:='greek_mixeddictionary'
       else result:='Mixed dictionary order';
  121: if b then result:='greek_altdictionary'
       else result:='Dictionary order, case-sensitive, accent-sensitive';
  124: if b then result:='greek_nocasedict'
       else result:='Dictionary order, case-insensitive, accent-insensitive';
 {1254 Turkish}
  128: if b then result:='bin_cp1254'
       else result:='Binary order';
  129: if b then result:='dictionary_1254'
       else result:='Dictionary order, case-sensitive';
  130: if b then result:='nocase_1254'
       else result:='Dictionary order, case-insensitive';
 {1255 Hebrew}
  136: if b then result:='bin_cp1255'
       else result:='Binary order';
  137: if b then result:='dictionary_1255'
       else result:='Dictionary order, case-sensitive';
  138: if b then result:='nocase_1255'
       else result:='Dictionary order, case-insensitive';
 {1256 Arabic}
  144: if b then result:='bin_cp1256'
       else result:='Binary order';
  145: if b then result:='dictionary_1256'
       else result:='Dictionary order, case-sensitive';
  146: if b then result:='nocase_1256'
       else result:='Dictionary order, case-insensitive';
 {1257 Baltic}
  152: if b then result:='bin_cp1257'
       else result:='Binary order';
  153: if b then result:='dictionary_1257'
       else result:='Dictionary order, case-sensitive';
  154: if b then result:='nocase_1257'
       else result:='Dictionary order, case-insensitive';
  155: if b then result:='etidic'
       else result:='Estonian dictionary order, case-sensitive';
  156: if b then result:='etinc'
       else result:='Estonian dictionary order, case-insensitive';
  157: if b then result:='lvidic'
       else result:='Latvian dictionary order, case-sensitive';
  158: if b then result:='lvinc'
       else result:='Latvian dictionary order, case-insensitive';
  159: if b then result:='lthdic'
       else result:='Lithuanian dictionary order, case-sensitive';
  160: if b then result:='lthnc'
       else result:='Lithuanian dictionary order, case-insensitive';
 else result:='unknown';
 end; {case}
end;

function mtfGetSortOrderName(order:dword):string;
begin result:=mtfGetSortOrderStr(order,true) end;

function mtfGetSortOrderDescr(order:dword):string;
begin result:=mtfGetSortOrderStr(order,false) end;

function mtfGetUnicodeLocaleStr(locale:dword):string;
{Unicode Collation
Unicode collation acts as a sort order for Unicode data.
This is separate from the sort order for non-Unicode data.

A Unicode collation consists of a locale and several comparison styles.
Locales are usually named after countries or cultural regions.They sort
characters as is standard in that area. The Unicode collation still
provides a sort order for all characters in the Unicode standard, but
precedence is given to the locale specified. Here are the locales
available in Microsoft SQL Server.
1988-98 Microsoft Corporation.}
begin
 case locale of
    1025: result:='Arabic (Saudi Arabia)'; // 1.5
    1026: result:='Bulgarian';             // 1.5
    1027: result:='Catalan';
    1028: result:='Chinese Stroke Count (Taiwan Region)';
    1029: result:='Czech';
    1030: result:='Danish';                // 1.5
    1031: result:='German (Standard)';     // 1.5 'German'
    1032: result:='Greek';                 // 1.5
    1033: result:='English (United States)'; // 1.5 'General Unicode'
    1034: result:='Spanish (Traditional Sort)'; // 1.5 'Spanish Traditional'
    1035: result:='Finnish';               // 1.5
    1036: result:='French (Standard)';     // 1.5 'French'
    1037: result:='Hebrew';                // 1.5
    1038: result:='Hungarian';
    1039: result:='Icelandic';
    1040: result:='Italian';
    1041: result:='Japanese';
    1042: result:='Korean (Extended Wansung)'; // 1.5 'Korean'
    1043: result:='Dutch (Standard)';      // 1.5 'Dutch'
    1044: result:='Norwegian (Bokmal)';    // 1.5 'Norwegian/Danish'
    1045: result:='Polish';
    1046: result:='Portuguese (Brazil)';   // 1.5 'Portuguese'
    1048: result:='Romanian';
    1049: result:='Russian';               // 1.5
    1050: result:='Croatian';
    1051: result:='Slovak';
    1052: result:='Albanian ? Macedonian'; // 1.5 ??
    1053: result:='Swedish';               // 1.5 'Swedish/Finnish'
    1054: result:='Thai';
    1055: result:='Turkish';               // 1.5
    1056: result:='Urdu';                  // 1.5
    1057: result:='Indonesian';            // 1.5
    1058: result:='Ukrainian';
    1059: result:='Byelorussian';          // 1.5
    1060: result:='Slovenian';
    1061: result:='Estonian';
    1062: result:='Latvian';
    1063: result:='Lithuanian';
    1065: result:='Farsi';                 // 1.5
    1066: result:='Vietnamese';
    1069: result:='Basque';                // 1.5
    1071: result:='Macedonian';
    1080: result:='Faeroese';              // 1.5
    1081: result:='Hindi';                 // 1.5
    2049: result:='Arabic (Iraq)';         // 1.5
    2052: result:='Chinese (People''s Republic of China)'; // 1.5 'Chinese Punctuation'
    2055: result:='German (Switzerland)';  // 1.5
    2057: result:='English (Britain)';     // 1.5 'UK English'
    2058: result:='Spanish (Mexico)';      // 1.5
    2060: result:='French (Belgium)';      // 1.5
    2064: result:='Italian (Switzerland)'; // 1.5
    2067: result:='Dutch (Belgium)';       // 1.5
    2068: result:='Norwegian (Nynorsk)';   // 1.5
    2070: result:='Portuguese (Standard)'; // 1.5
    2074: result:='Serbian (Latin)';       // 1.5
    2087: result:='Lithuanian';            // 1.5
    3073: result:='Arabic (Egypt)';        // 1.5
    3079: result:='German (Austria)';      // 1.5
    3081: result:='English (Australia)';   // 1.5
    3082: result:='Spanish (Modern Sort)'; // 1.5 'Spanish Modern'
    3084: result:='French (Canada)';       // 1.5
    3098: result:='Serbian (Cyrillic)';    // 1.5
    4097: result:='Arabic (Libya)';        // 1.5
    4100: result:='Chinese (Singapore)';   // 1.5
    4103: result:='German (Luxembourg)';   // 1.5
    4105: result:='English (Canada)';      // 1.5
    4106: result:='Spanish (Guatemala)';   // 1.5
    4108: result:='French (Switzerland)';  // 1.5
    4174: result:='Hungarian';             // 1.5
    5121: result:='Arabic (Algeria)';              // 1.5
    5127: result:='German (Liechtenstein)';        // 1.5
    5129: result:='English (New Zealand)';         // 1.5
    5130: result:='Spanish (Costa Rica)';          // 1.5
    5132: result:='French (Luxembourg)';           // 1.5
    6145: result:='Arabic (Morocco)';              // 1.5
    6153: result:='English (Ireland)';             // 1.5
    6154: result:='Spanish (Panama)';              // 1.5
    7169: result:='Arabic (Tunisia)';              // 1.5
    7177: result:='English (South Africa)';        // 1.5
    7178: result:='Spanish (Dominican Republic)';  // 1.5
    8193: result:='Arabic (Oman)';                 // 1.5
    8201: result:='English (Jamaican)';            // 1.5
    8202: result:='Spanish (Venezuela)';           // 1.5
    9217: result:='Arabic (Yemen)';                // 1.5
    9225: result:='English (Carribean)';           // 1.5
    9226: result:='Spanish (Colombia)';            // 1.5
   10241: result:='Arabic (Syria)';                // 1.5
   10250: result:='Spanish (Peru)';                // 1.5
   11265: result:='Arabic (Jordan)';               // 1.5
   11274: result:='Spanish (Argentina)';           // 1.5
   12289: result:='Arabic (Lebanon)';              // 1.5
   12298: result:='Spanish (Ecuador)';             // 1.5
   13313: result:='Arabic (Kuwait)';               // 1.5
   13322: result:='Spanish (Chile)';               // 1.5
   14337: result:='Arabic (United Arab Emirates)'; // 1.5
   14346: result:='Spanish (Uruguay)';             // 1.5
   15361: result:='Arabic (Bahrain)';              // 1.5
   15370: result:='Spanish (Paraguay)';            // 1.5
   16385: result:='Arabic (Qatar)';                // 1.5
   16394: result:='Spanish (Bolivia)';             // 1.5
   33280: result:='Binary Order';
   66567: result:='German (PhoneBook Sort)'; // 1.5 'German Phone Book'
   66574: result:='Hungarian Technical';
   66577: result:='Japanese (Unicode)';     // 1.5 'Japanese Unicode'
   66578: result:='Korean';                 // 1.5 'Korean Unicode'
   66615: result:='Georgian (Modern Sort)'; // 1.5 'Georgian Modern'
  133124: result:='Chinese Stroke Count';
  197636: result:='Chinese Bopomofo (Taiwan Region)';
 else result:='unknown';
 end; {case}
end;
end.
